/************************************************************************/
/*									*/
/*	File:	aoext.h							*/
/*									*/
/*	External declarations for the assembly language	peephole	*/
/*	optimizer.  This include file is to be used with all the	*/
/*	"aoX.c"	files.							*/
/*									*/
/*		Written	by Kirk	Bailey of Logical Systems.		*/
/*									*/
/*		Copyright (c) 1984-1986	Logical	Systems.		*/
/*									*/
/*				04/20/86				*/
/*									*/
/************************************************************************/

/*
 *	I/O definitions.
 */

extern	char	ifnbuf[FNSIZE +	1];	/* Input filename buffer */
extern	STREAM	in_fp;			/* Input file pointer */
extern	char	ofnbuf[FNSIZE +	1];	/* Output filename buffer */
extern	STREAM	out_fp;			/* Output file pointer */
extern	char	rfnbuf[FNSIZE +	1];	/* Restart linkage filename buffer */
extern	STREAM	rst_fp;			/* Restart linkage file	pointer	*/

/*
 *	General	definitions.
 */

extern	UINT	b_added;		/* # of	bytes of code added */
extern	UINT	b_read;			/* # of	bytes of code read */
extern	UINT	b_saved;		/* # of	bytes saved by optimizer */
extern	BOOL	dseg;			/* TRUE	if in data segment */
extern	char	entrypt[SYMNMESIZE + 1];/* Entry point if linkrst TRUE */
extern	BOOL	freq;			/* TRUE	if checking "call" freq. */
extern	UINT	jqcsize;		/* Bytes of code in jump queue */
extern	BOOL	jqfull;			/* TRUE	if jump	queue ever full	*/
extern	BOOL	linkrst;		/* TRUE	if generating restart link */
extern	struct	queue	jq;		/* JP->JR conversion queue */
extern	struct	pbuf	pb;		/* Parsing/sizing buffers */
extern	struct	rstslot	restart[8];	/* Restart linkage info	*/
extern	BOOL	rom;			/* TRUE	if reading rom code */
extern	BOOL	rst;			/* TRUE	if linking restart vectors */
extern	struct	symtab	*st;		/* Beginning of	symbol table */
extern	struct	symtab	*stend;		/* Last	entry of symbol	table */
extern	BOOL	stfull;			/* TRUE	if symbol table	ever full */
extern	BOOL	verbose;		/* Default: make output	terse */

/*
 *	Function definitions.
 */

extern	struct	symtab	*add_jmp();
extern	struct	symtab	*add_lab();
extern	VOID	banner();
extern	VOID	chkfreq();
extern	VOID	do_jopts();
extern	VOID	fatal();
extern	BOOL	findit();
extern	STREAM	fopen();
extern	char	get_jq();
extern	BOOL	isreg();
extern	BOOL	isrp();
extern	BOOL	isxrp();
extern	VOID	lnk_rst();
extern	struct	symtab	*lookup();
extern	VOID	main();
extern	VOID	makefn();
extern	BOOL	match();
extern	int	nc1();
extern	UINT	one();
extern	VOID	optimize();
extern	BOOL	parse();
extern	BOOL	read_jq();
extern	VOID	r_rst();

extern	UINT	scase1();
extern	UINT	scase2();
extern	UINT	scase3();
extern	UINT	scase4();
extern	UINT	scase5();
extern	UINT	scase6();
extern	UINT	scase7();
extern	UINT	scase8();
extern	VOID	size();
extern	UINT	size1();
extern	UINT	size2();
extern	UINT	size3();
extern	UINT	size4();
extern	UINT	size5();
extern	UINT	size6();
extern	UINT	size7();
extern	UINT	size8();
extern	UINT	size9();
extern	UINT	size10();
extern	UINT	size11();
extern	UINT	size12();
extern	STRING	strchr();
extern	UINT	two();
extern	VOID	usagerr();
extern	UINT	zero();

/*
 *	The following functions	may be called only for side effects.
 */
/*lint +fvr */

extern	UINT	ii();
extern	int	nextc();
extern	BOOL	put_jq();
extern	char	scan_jq();
extern	BOOL	write_jq();

/*lint -fvr */

