/**************************************************************************\
*									   *
*   CTP.C   -	Zeichenklassifizierungsfunktionen			   *
*									   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Flagbits	  */
/**************************************************************************/

#define	CTUPPER	0x0001	      /* Grossbuchstabe				  */
#define	CTLOWER	0x0002	      /* Kleinbuchstabe				  */
#define	CTDIGIT	0x0004	      /* Zahl					  */
#define	CTHEXCH	0x0008	      /* Hexbuchstabe				  */
#define	CTCNTRL	0x0010	      /* Controlzeichen				  */
#define	CTSPACE	0x0020	      /* leeres	Zeichen				  */
#define	CTPUNCT	0x0040	      /* nicht-alphanumerisches	druckbares Z.	  */
#define	CTPRINT	0x0080	      /* druckbares Zeichen			  */
#define	CTGRAPH	0x0100	      /* bei Druck sichtbares Zeichen		  */
#define	CTLABEL	0x0200	      /* in Assemblerlabel gueltiges Zeichen	  */
#define	CTULINE	0x0400	      /* Tiefstrich				  */





/*						  Klassifizierungsarray	  */
/**************************************************************************/

static unsigned	myctype[256] =

  {
    CTCNTRL,							/* 00 NUL */
    CTCNTRL,							/* 01 SOH */
    CTCNTRL,							/* 02 STX */
    CTCNTRL,							/* 03 ETX */
    CTCNTRL,							/* 04 EOT */
    CTCNTRL,							/* 05 ENQ */
    CTCNTRL,							/* 06 ACK */
    CTCNTRL,							/* 07 BEL */
    CTCNTRL,							/* 08 BS  */
    CTCNTRL | CTSPACE,						/* 09 HT  */
    CTCNTRL | CTSPACE,						/* 0A LF  */
    CTCNTRL | CTSPACE,						/* 0B VT  */
    CTCNTRL | CTSPACE,						/* 0C FF  */
    CTCNTRL | CTSPACE,						/* 0D CR  */
    CTCNTRL,							/* 0E SO  */
    CTCNTRL,							/* 0F SI  */
    CTCNTRL,							/* 10 DLE */
    CTCNTRL,							/* 11 DC1 */
    CTCNTRL,							/* 12 DC2 */
    CTCNTRL,							/* 13 DC3 */
    CTCNTRL,							/* 14 DC4 */
    CTCNTRL,							/* 15 NAK */
    CTCNTRL,							/* 16 SYN */
    CTCNTRL,							/* 17 ETB */
    CTCNTRL,							/* 18 CAN */
    CTCNTRL,							/* 19 EM  */
    CTCNTRL,							/* 1A SUB */
    CTCNTRL,							/* 1B ESC */
    CTCNTRL,							/* 1C FS  */
    CTCNTRL,							/* 1D GS  */
    CTCNTRL,							/* 1E RS  */
    CTCNTRL,							/* 1F US  */
	      CTSPACE |	CTPRINT,				/* 20 '	' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 21 '!' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 22 '"' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 23 '#' */
	      CTGRAPH |	CTPRINT	| CTPUNCT | CTLABEL,		/* 24 '$' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 25 '%' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 26 '&' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 27 ''' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 28 '(' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 29 ')' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 2A '*' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 2B '+' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 2C ',' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 2D '-' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 2E '.' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 2F '/' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 30 '0' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 31 '1' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 32 '2' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 33 '3' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 34 '4' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 35 '5' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 36 '6' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 37 '7' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 38 '8' */
    CTDIGIT | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 39 '9' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 3A ':' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 3B ';' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 3C '<' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 3D '=' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 3E '>' */
	      CTGRAPH |	CTPRINT	| CTPUNCT | CTLABEL,		/* 3F '?' */
	      CTGRAPH |	CTPRINT	| CTPUNCT | CTLABEL,		/* 40 '@' */
    CTUPPER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 41 'A' */
    CTUPPER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 42 'B' */
    CTUPPER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 43 'C' */
    CTUPPER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 44 'D' */
    CTUPPER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 45 'E' */
    CTUPPER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 46 'F' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 47 'G' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 48 'H' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 49 'I' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 4A 'J' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 4B 'K' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 4C 'L' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 4D 'M' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 4E 'N' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 4F 'O' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 50 'P' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 51 'Q' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 52 'R' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 53 'S' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 54 'T' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 55 'U' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 56 'V' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 57 'W' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 58 'X' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 59 'Y' */
    CTUPPER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 5A 'Z' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 5B '[' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 5C '\' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 5D ']' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 5E '^' */
	      CTGRAPH |	CTPRINT	| CTPUNCT | CTLABEL | CTULINE,	/* 5F '_' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 60 '`' */
    CTLOWER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 61 'a' */
    CTLOWER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 62 'b' */
    CTLOWER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 63 'c' */
    CTLOWER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 64 'd' */
    CTLOWER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 65 'e' */
    CTLOWER | CTGRAPH |	CTPRINT	| CTHEXCH | CTLABEL,		/* 66 'f' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 67 'g' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 68 'h' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 69 'i' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 6A 'j' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 6B 'k' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 6C 'l' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 6D 'm' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 6E 'n' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 6F 'o' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 70 'p' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 71 'q' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 72 'r' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 73 's' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 74 't' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 75 'u' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 76 'v' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 77 'w' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 78 'x' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 79 'y' */
    CTLOWER | CTGRAPH |	CTPRINT	|	    CTLABEL,		/* 7A 'z' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 7B '{' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 7C '|' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 7D '}' */
	      CTGRAPH |	CTPRINT	| CTPUNCT,			/* 7E '~' */
    CTCNTRL							/* 7F DEL */
  };





/*					     Klassifizierungsfunktionen	  */
/**************************************************************************/

typedef	unsigned char u_ch;

/*
int isalpha(c)
u_ch c;
{ return (myctype[c] & (CTUPPER|CTLOWER)	       ); }
int isspace(c)
u_ch c;
{ return (myctype[c] & (CTSPACE)		       ); }
int isupper(c)
u_ch c;
{ return (myctype[c] & (CTUPPER)		       ); }
int islower(c)
u_ch c;
{ return (myctype[c] & (CTLOWER)		       ); }
int isdigit(c)
u_ch c;
{ return (myctype[c] & (CTDIGIT)		       ); }
*/
int ishdigit(c)
u_ch c;
{ return (myctype[c] & (CTHEXCH)		       ); }
/*
int isxdigit(c)
u_ch c;
{ return (myctype[c] & (CTDIGIT|CTHEXCH)	       ); }
int isalnum(c)
u_ch c;
{ return (myctype[c] & (CTDIGIT|CTUPPER|CTLOWER)       ); }
int iscntrl(c)
u_ch c;
{ return (myctype[c] & (CTCNTRL)		       ); }
int ispunct(c)
u_ch c;
{ return (myctype[c] & (CTPUNCT)		       ); }
int isprint(c)
u_ch c;
{ return (myctype[c] & (CTPRINT)		       ); }
int isgraph(c)
u_ch c;
{ return (myctype[c] & (CTGRAPH)		       ); }
*/
int islabel(c)
u_ch c;
{ return (myctype[c] & (CTLABEL)		       ); }
int issym(c)
u_ch c;
{ return (myctype[c] & (CTULINE|CTUPPER|CTLOWER|CTDIGIT) ); }
int issymf(c)
u_ch c;
{ return (myctype[c] & (CTULINE|CTUPPER|CTLOWER)	); }
/*
int isascii(c)
u_ch c;
{ return ((unsigned)c < 0x80			       ); }
*/


/* Ende	von CTP.C */
