/**************************************************************************\
*									   *
*   LIB.C   -	 unido X-Mac, Librarian					   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/



/*
 * Aufruf :
 *
 *
 *   LIB oldlib	newlib -d modules
 *
 *     Library oldlib in Library newlib	kopieren, dabei	alle Module in der
 *     Modulliste modules loeschen.
 *
 *
 *   LIB oldlib	newlib -a files
 *
 *     Library oldlib in Library newlib	kopieren, dabei	REL-Module aus der
 *     Dateiliste files	in der angegebenen Reihenfolge an newlib anhaengen.
 *     Wenn oldlib = newlib, dann Erzeugen einer neuen Library.
 *
 *
 *   LIB lib -x	modules
 *
 *     Alle Module aus der Modulliste modules aus der Library lib als REL-
 *     Files extrahieren (nicht	loeschen).
 *
 *
 *   LIB lib -t
 *
 *     Alle Module der Library lib auflisten.
 *
 *
 *   LIB lib -l
 *
 *     Alle Module der Library lib einschliesslich Entries und Externals
 *     auflisten.
 *
 *
 *   LIB cmdfile
 *
 *     Alle Anweisungen	fuer LIB stehen	in der Datei cmdfile, Extension
 *     muss ".CMD" sein.  Die Anweisungen muessen genauso angegeben werden
 *     wie in der Programmaufrufzeile ohne Kommandodatei, allerdings muss
 *     jeder Parameter/Optionseintrag in genau eine Zeile geschrieben
 *     werden.
 *
 *
 *
 *   Datei Extensions :
 *
 *	- .rel = relokatibles Objektmodul
 *	  .lib = Bibliothek mit	Objektmodulen
 *	  .cmd = Kommandodatei fuer LIB
 *
 *
 */





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <stdlib.h>
#include <string.h>			/* Stringfunktionen benutzt	  */
#include "all.h"			/* allgemeine Festlegungen	  */
#include "uti.h"
#include "ctp.h"
#include "rel.h"			/* Aufbau REL			  */
#include "rele.h"			/* Externals REL.C		  */





/*								Defines	  */
/**************************************************************************/

			      /* Dateiextensions :			  */
#define	MODEXT ".rel"	      /*   Microsoft REL-Modul			  */
#define	LIBEXT ".lib"	      /*   Microsoft REL-Library		  */
#define	CMDEXT ".cmd"	      /*   Extension Kommandofile		  */

#define	ARGBSZ 32000	      /* Puffergroesse CMD-File			  */
#define	ARGMAX 256	      /* maximale Anzahl Argumente bei Aufruf	  */





/*	      externe nicht-int-Funktionen (nicht aus stdio.h/string.h)	  */
/**************************************************************************/

/* extern char *farmalloc();
   extern long farcoreleft();
   extern FILE *fopena();
   extern FILE *fopenb(); no longer used */





/*								Globals	  */
/**************************************************************************/

char	   *argbuf;	      /* Zeiger	auf Anfang Argumentenbuffer	  */
char	   *myargv[ARGMAX];   /* "mein"	argv[]				  */
int	    myargc;	      /* "mein"	argc				  */
char	    argfn[FNSIZE+1];  /* Name der Linkkommandodatei LNK		  */
FILE	   *argfile;	      /* LNK-Datei				  */

char	    infn[FNSIZE+1];   /* Name der Eingabedatei			  */
char	    outfn[FNSIZE+1];  /* Name der Ausgabedatei			  */


void strupper __ARGS((char *));
VOID usage __ARGS((void));
BOOLEAN	extend __ARGS((char *, char *, char *));
VOID table __ARGS((void));
VOID list __ARGS((void));
VOID extract __ARGS((void));
VOID delete __ARGS((void));
VOID append __ARGS((void));

/**************************************************************************\
*									   *
* action      :	 Hauptprogramm.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 argc, argv  - Aufrufparameter				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 argbuf	  -  Zeiger auf	Anfang Argumentenbuffer		   *
*		 myargv	  -  eigenes argv[]				   *
*		 myargc	  -  eigenes argc				   *
*		 argfn	  -  Name LNK-Datei, falls angegeben		   *
*		 argfile  -  LNK-Datei					   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 Errorcode 1 bei Fehlern				   *
*		 Errorcode 0 sonst					   *
*									   *
\**************************************************************************/

void main(argc,argv)

int	argc;
char   *argv[];

  {
    int	   argnbr;	      /* Nummer	der aktuellen Option		  */
    int	   len;		      /* Laenge	Zahl in	Option			  */
    char  *cptr;	      /* fuer das Scannen nach LNK-Datei	  */



    /* Startmeldung (Identifikation) ausgeben */

    puts("unido REL-Librarian Version 1.0");
    puts("ported to Linux by dl4sdc");


    /* Speicher	fuer holen und zuweisen	(nicht dynamisch) */

    if (!(argbuf = malloc((long)ARGBSZ)))		   /* zuweisen	  */
      fatal("Not enough buffer memory","");		   /* kein Platz  */



    /* "mein" argv erstellen, CMD-Datei	abarbeiten */

    myargc = argnbr = 0;			       /* Start		  */
    cptr = argbuf;				       /* Argumentbuffer  */
    while (argnbr < argc)			       /* alle Argumente  */
      {						       /* durchgehen	  */
	/* strupper(argv[argnbr]);			  alles gross	  */
	if (	*argv[argnbr] != '-'		       /* name.CMD ?	  */
	     &&	(len = strlen(argv[argnbr])) > 4
	     &&	!strcmp(CMDEXT,argv[argnbr] + len - 4)
	   )
	  {					       /* CMD-Datei	  */
	    strcpy(argfn,argv[argnbr++]);	       /* oeffnen	  */
	    if (!(argfile = fopen(argfn,"r")))
	      fatal(argfn," - Cannot open");
	    while (fgets(cptr,FNSIZE+4,argfile))       /* einlesen	  */
	      if (    (len = strlen(cptr)) > 1
		   && *cptr != '\n'
		   && *cptr != ' '
		 )
		{
		  if (	  myargc == ARGMAX
		       || cptr + 2 * (FNSIZE + 4) >= argbuf + ARGBSZ
		     ) fatal ("Argument	buffer overflow","");
		  myargv[myargc++] = cptr;	       /* Args.	zuordnen  */
		  /* strupper(cptr); */
		  cptr += len -	1;
		  if (*cptr != '\n') ++cptr;
		  *cptr++ = '\0';
		}
	    continue;				       /* naechstes Arg.  */
	  }
	myargv[myargc++] = argv[argnbr++];	       /* Arg. kopieren	  */
      }



    /* Kommandoparameter auswerten und Kommando	ausfuehren */

    if (myargc < 3) usage();			  /* -L/-T = 3 Argumnte	  */
    strcpy(infn,myargv[1]);			  /* 1.	Arg immer Libname */
    extend(infn,LIBEXT,LIBEXT);			  /* .LIB anhaengen	  */
    strcpy(outfn,myargv[2]);			  /* 2.	Arg Libname oder  */
    if (*outfn == '-')				  /* Option -L/-T/-X	  */
      switch (outfn[1])
	{
	  case 't' :  table();					 break;
	  case 'l' :  list();					 break;
	  case 'x' :  if (myargc < 4) usage(); else extract();	 break;
	  default  :  usage();
	}
    else
      {
	if (myargc < 5)	usage();		  /* -D/-A > 4 Argumente  */
	extend(outfn,LIBEXT,LIBEXT);		  /* Output-Libname .LIB  */
	if (*myargv[3] == '-')			  /* muss Option sein	  */
	  switch (myargv[3][1])
	    {
	      case 'd' :  delete();   break;
	      case 'a' :  append();   break;
	      default  :  usage();
	    }
	else
	  usage();
      }
  }





/**************************************************************************\
*									   *
* action      :	 Wenn Zeichen c	ein Kleinbuchstabe ist,	umwandeln in	   *
*		 Grossbuchstabe.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 c  -  umzuwandelndes Zeichen				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 c umgewandelt (s.o.)					   *
*									   *
\**************************************************************************/

int chupper(c)

int c;

  {
    return ((c>='a' && c<='z') ? c - ('a' - 'A') : c);
  }





/**************************************************************************\
*									   *
* action      :	 Alle Kleinbuchstaben im String	str in Grossbuchstaben	   *
*		 umwandeln.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 str  -	 Zeiger	auf nullterminierten String		   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

void strupper(str)

char *str;

  {
    while(*str)
      {
	*str = chupper(*str);
	++str;
      }
  }





/**************************************************************************\
*									   *
* action      :	 Programmabbruch mit Bedienungshinweis.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 (Programmabbruch mit Errorcode	1)			   *
*									   *
\**************************************************************************/

VOID usage()
  {
    fatal("Usage:\nLIB oldlib newlib -d	modules\nLIB oldlib newlib -a files\n",
	  "LIB lib -x modules\nLIB lib -t\nLIB lib -l\nLIB cmdfile");
  }





/**************************************************************************\
*									   *
* action      :	 Falls Dateiname keine Extension hat, bekommt er ext1.	   *
*		 Hat er	eine, dann muss	diese entweder ext1 oder ext2	   *
*		 entsprechen.						   *
*									   *
*		 Programmabbruch mit Meldung bei zu langem Filenamen oder  *
*		 vorhandener nicht ext1	oder ext2 entsprechender	   *
*		 Extension						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 fn	-   Dateiname					   *
*		 ext1	-   1. Extension				   *
*		 ext2	-   2. Extension				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 TRUE, wenn Extension ext2 entspricht und FALSE	sonst	   *
*									   *
\**************************************************************************/

BOOLEAN	extend(fn,ext1,ext2)

char *fn;
char *ext1;
char *ext2;

  {
    char   *cp;

    cp = fn + strlen(fn) - 1;			  /* Extension-Punkt	  */
    while (	cp != fn			  /* finden (Suche von	  */
	    && *cp != '\\'			  /* hinten, da	auch z.B. */
	    && *cp != '/'			  /* ".\ABC.EXT" gueltig) */
	    && *cp != '.' ) --cp;
    if (*cp == '.')
      {
	if (strcmp(cp,ext2) == 0) return (YES);
	if (strcmp(cp,ext1) == 0) return (NO);
	fatal(fn," - Invalid extension");	  /* Falsche Extension	  */
      }
    if (strlen(fn) + strlen(ext1) > FNSIZE)	  /* Laenge checken	  */
      fatal(fn," - Too long");
    strcat(fn,ext1);				  /* Extension anhaengen  */
    return(NO);
  }





/**************************************************************************\
*									   *
* action      :	 Symbolstring sym linksbuendig in einem	9-Zeichen-Feld	   *
*		 ausgeben (Name	+ Spaces) an stdout.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 sym	-   Zeiger auf nullterminierten	Symbolstring,	   *
*			    Laenge muss	kleiner	gleich 9 sein		   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 n	-  Formatzaehler				   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID prisym(sym)

char *sym;

  {
    int	n;

    n =	9;				/* feste Feldlaenge		 */
    while (*sym)			/* Symbol ausgeben		 */
      {
	putchar(*sym++);
	--n;				/* Feldlaengenzaehler		 */
      }
    while (n)				/* Feld	mit Spaces auffuellen	 */
      {
	putchar(' ');
	--n;
      }
  }





/**************************************************************************\
*									   *
* action      :	 T-Option ausfuehren. Alle Modulnamen der Library infn	   *
*		 sowie Programm- und Datenbereichlaengen listen	und	   *
*		 Startadressen ausgeben.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 infn	-  Dateiname der auszugebenden Library		   *
*									   *
* r/w globals :	 inrel	-  Filestrukturzeiger fuer infn			   *
*		 (symbol, field, item und weitere siehe	REL.C)		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID table()
  {
    if (!(inrel	= fopen(infn,"rb")))		       /* Lib oeffnen	  */
      fatal(infn," - Cannot open");
    printf("\nmodule list library %s\n\n",infn);
    do
      switch (getrel())
	{
	  case PNAME :	prisym(symbol);		   break; /* Modulname	  */
	  case DSIZE :	printf(" %04x\"",field);   break; /* Datenbereich */
	  case PSIZE :	printf(" %04x'",field);	   break; /* Programmber. */
	  case EPROG :	if (type == PREL)		  /* ggf. Start	  */
			  printf(" - start at %04x'",field);
			puts("");
			break;
	}
    while (item	!= EFILE);			       /* bis Fileende	  */
    puts("");
    fclose(inrel);				       /* Lib schliessen  */
  }





/**************************************************************************\
*									   *
* action      :	 L-Option ausfuehren. Alle Module mit Einsprungpunkten	   *
*		 und Externals auflisten.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 infn	-  Dateiname der auszugebenden Library		   *
*									   *
* r/w globals :	 inrel	-  Filestrukturzeiger fuer infn			   *
*		 (symbol, item und weitere siehe REL.C)			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID list()
  {
    BOOLEAN firste;			/* YES:	Ausgabe	1. Entrypoint	  */
    BOOLEAN firstx;			/* YES:	Ausgabe	1. External	  */
    int	    n;				/* Zaehler Objekte/Zeile	  */

    if (!(inrel	= fopen(infn,"rb")))		       /* Lib oeffnen	  */
      fatal(infn," - Cannot open");
    printf("\nlibrary %s\n\n",infn);
    do
      switch (getrel())
	{
	  case PNAME  :	 firste	= firstx = YES;	       /* neues	Modul	  */
			 printf("module	    ");
			 prisym(symbol);
			 break;

	  case ENAME  :	 if (firste)		       /* Entrypoint	  */
			   {
			     firste = NO;	       /* war erster,	  */
			     n = 0;		       /* neue Zeile	  */
			     printf("\nentries	  ");  /* Kennung	  */
			   }
			 if (n++ == 6)		       /* neue Zeile ?	  */
			   {
			     n = 1;		       /* ja, 1. Symbol	  */
			     printf("\n		  ");  /* justieren	  */
			   }
			 prisym(symbol);	       /* Symbol ausgeben */
			 break;

	  case XCHAIN :	 if (firstx)		       /* External	  */
			   {
			     firstx = NO;	       /* war erstes,	  */
			     n = 0;		       /* neue Zeile	  */
			     printf("\nexternals  ");  /* Kennung	  */
			   }
			 if (n++ == 6)		       /* neue Zeile ?	  */
			   {
			     n = 1;		       /* ja, 1. Symbol	  */
			     printf("\n		  ");  /* justieren	  */
			   }
			 prisym(symbol);	       /* Symbol ausgeben */
			 break;

	  case EPROG  :	 puts("\n");		       /* Modulende	  */
			 break;
	}
    while (item	!= EFILE);		/* bis REL-Fileende durchgehen	  */
    puts("");
    fclose(inrel);			/* Library schliessen		  */
  }





/**************************************************************************\
*									   *
* action      :	 X-Option ausfuehren. Alle Module, die in der		   *
*		 Kommandozeile hinter dem -X angegeben sind, aus der	   *
*		 Library infn als REL-Files extrahieren	(nicht loeschen).  *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 infn	   -  Dateiname	der Library			   *
*		 myargc	   -  "mein" argc				   *
*		 myargv[]  -  "mein" argv				   *
*									   *
* r/w globals :	 inrel	-  Filestrukturzeiger fuer infn			   *
*		 outfn	-  Dateiname zu	extrahierendes REL-Modul	   *
*		 outrel	-  Filestrukturzeiger fuer outfn		   *
*		 (symbol, item und weitere siehe REL.C)			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID extract()
  {
    BOOLEAN   out;				  /* TRUE: Extrahieren !  */
    int	      n;				  /* Index myargv[]	  */

    if (!(inrel	= fopen(infn,"rb")))		  /* LIB-Datei oeffnen	  */
      fatal(infn," - Cannot open");
    printf("\nlibrary %s, extracting\n\n",infn);
    out	= NO;					  /* Default nicht extr.  */
    do						  /* LIB ganz durchgehen  */
      switch (getrel())				  /* REL-Item holen	  */
	{
	  case PNAME :	n = 2;			  /* Anfang neues Modul	  */
			while (++n < myargc)	  /* Name in Liste suchen */
			  if (strcmp(myargv[n],symbol) == 0)
			    {
			      strcpy(outfn,symbol);	    /* gefunden	  */
			      extend(outfn,MODEXT,MODEXT);
			      if (!(outrel = fopen(outfn,"wb")))
				fatal(outfn," -	Cannot open");
			      outrelinit();
			      putrel();		  /* Anfang neue Ausgabe- */
			      out = YES;	  /* datei		  */
			      puts(symbol);
			      break;
			    }
			break;

	  case EPROG :	if (out)		  /* Modulende		  */
			  {
			    putrel();
			    item = EFILE;
			    putrel();
			    item = EPROG;
			    out	= NO;
			    if (ferror(outrel))
			      fatal(outfn," - Write error");
			    fclose(outrel);
			  }
			break;

	  default    :	if (out) putrel();	  /* REL-Item schreiben	  */
			break;
	}
    while (item	!= EFILE);
    puts("");
    fclose(inrel);
  }





/**************************************************************************\
*									   *
* action      :	 D-Option ausfuehren. Library infn in neue Library outfn   *
*		 kopieren, dabei alle hinter dem -D in der Kommandozeile   *
*		 angegebenen Module loeschen.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 infn	   -  Dateiname	der alten Library		   *
*		 outfn	   -  Dateiname	der neuen Library		   *
*		 myargc	   -  "mein" argc				   *
*		 myargv[]  -  "mein" argv				   *
*									   *
* r/w globals :	 inrel	-  Filestrukturzeiger fuer infn			   *
*		 outrel	 -  Filestrukturzeiger fuer outfn		   *
*		 (symbol, item und weitere siehe REL.C)			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID delete()
  {
    BOOLEAN   out;			/* TRUE: nicht zu loeschen	  */
    int	      n;			/* Index in myargv[]		  */


    if (strcmp(infn,outfn) == 0)		  /* Librarynamensgleich- */
      fatal("Output library = input library",""); /* heit abfangen	  */
    if (!(inrel	= fopen(infn,"rb")))		  /* alte Library oeffnen */
      fatal(infn," - Cannot open");
    if (!(outrel = fopen(outfn,"wb")))		  /* neue Library anlegen */
      fatal(outfn," - Cannot open");
    printf("\ncopy library %s to %s, deleting\n\n",infn,outfn);
    out	= YES;					  /* Default kopieren	  */
    do
      switch (getrel())				  /* REL-Item holen	  */
	{
	  case PNAME :	n = 3;			  /* neues Modul	  */
			while (++n < myargc)	  /* in	Liste suchen	  */
			  if (strcmp(myargv[n],symbol) == 0)
			    {
			      out = NO;		  /* gefunden, nicht	  */
			      puts(symbol);	  /* kopieren		  */
			      break;
			    }
			  if (n	== myargc) putrel();
			break;

	  case EPROG :	if (out)		  /* Modulende		  */
			  putrel();
			else
			  out =	YES;
			break;

	  default    :	if (out) putrel();	  /* REL-Item kopieren	  */
			break;
	}
    while (item	!= EFILE);			  /* bis Input am Ende	  */
    puts("");
    fclose(inrel);				  /* Input schliessen	  */
    if (ferror(outrel))				  /* Schreibfehler ?	  */
      fatal(outfn," - Write error");
    fclose(outrel);				  /* Output schliessen	  */
  }





/**************************************************************************\
*									   *
* action      :	 A-Option ausfuehren. Library infn in neue Library outfn   *
*		 kopieren, dabei alle hinter dem -A in der Kommandozeile   *
*		 angegebenen REL-Files anhaengen.			   *
*									   *
*		 Wenn infn == outfn Erzeugen einer neuen Library.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 infn	   -  Dateiname	der alten Library		   *
*		 outfn	   -  Dateiname	der neuen Library		   *
*		 myargc	   -  "mein" argc				   *
*		 myargv[]  -  "mein" argv				   *
*									   *
* r/w globals :	 inrel	-  Filestrukturzeiger fuer infn			   *
*		 outrel	 -  Filestrukturzeiger fuer outfn		   *
*		 (symbol, item und weitere siehe REL.C)			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID append()
  {
    int	n;				     /*	Index in myargv[]	  */

    if (!(outrel = fopen(outfn,"wb")))	     /*	neue Library anlegen	  */
      fatal(outfn," - Cannot open");
    if (strcmp(infn,outfn) == 0)	     /*	nur neue Library ?	  */
      printf("\ncreating library %s with\n\n",outfn);
    else
      {
	if (!(inrel = fopen(infn,"rb")))     /*	nein, alte Lib.	oeffnen	  */
	  fatal(infn," - Cannot	open");
	printf("\ncopy library %s to %s, appending\n\n",infn,outfn);
	LOOP
	  {				     /*	und in neue kopieren	  */
	    if (getrel() != EFILE)
	      putrel();
	    else
	      break;
	  }
	fclose(inrel);
      }
    for	(n = 4;	n < myargc; ++n)	     /*	alle Files aus Liste	  */
      {					     /*	anhaengen		  */
	strcpy(infn,myargv[n]);
	extend(infn,MODEXT,MODEXT);
	if (!(inrel = fopen(infn,"rb")))
	  fatal(infn," - Cannot	open");
	inrelinit();
	LOOP
	  {
	    if (getrel() != EFILE)
	      {
		putrel();
		if (item == PNAME) puts(symbol);
	      }
	    else
	      break;
	  }
	fclose(inrel);
      }
    item = EFILE;			     /*	Library-Ende		  */
    putrel();
    puts("");
    if (ferror(outrel))
      fatal(outfn," - Write error");
    fclose(outrel);
  }



/* Ende	von LIB.C */
