/**************************************************************************\
*									   *
*   CMIT.C   -	 unido X-Mac, Compilieren einer	MIT-Tabelle in Klartext	   *
*		 zu einem uebersetzbaren C-Source fuer X-Mac		   *
*									   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/



/*
 *   Aufruf :
 *
 *   CMIT <Dateispezifikation>
 *
 *   CMIT erzeugt aus dem Klartext der angegebenen MIT-Datei
 *   den zu uebersetzenden Source der MIT, TAB.C.
 *   Die Datei-Extension der MIT-Datei ist default "MIT",
 *   falls nichts anderes angegeben ist.
 *
 */





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <string.h>			/* Stringfunktionen benutzt	  */
#include "all.h"			/* allgemeine Festlegungen	  */
#include "mac.h"			/* MICOUNT			  */





/*	      externe nicht-int-Funktionen (nicht aus stdio.h/string.h)	  */
/**************************************************************************/

extern char *skip();
extern FILE *fopena();





/*							   Festlegungen	  */
/**************************************************************************/

#define	MIBUFSZ	   8000	      /* MIT-Buffer Maximalgroesse in Bytes	  */
#define	MIOPNDS	    300	      /* Maximalanzahl Operandenformate		  */





/*								Globals	  */
/**************************************************************************/

char   mitfn[FNSIZE + 1];	  /* Path/Dateiname MIT-Datei		  */

				  /* Tabelle der Maschineninstruktionen	: */
int    mitndx[MICOUNT];		  /*   MIT Indizes (hash -> which)	  */
int    mitnxt[MICOUNT];		  /*   Synonymenkette der MIT		  */
int    mitidx[MICOUNT];		  /*   Indizes fuer Syntax der Mnemonics  */
char   mitbuf[MIBUFSZ];		  /*   Puffer fuer Instruktions-Syntax	  */

int    opnds;			  /* Anzahl Operandenfelder MIT-Buffer	  */
int    top;			  /* Anzahl Mnemonics im MIT-Buffer	  */

int    looks;			  /* wird fuer CMIT.C nicht gebraucht,	  */
				  /* aber im Modul MIT.C angesprochen	  */





/**************************************************************************\
*									   *
* action      :	 Hauptprogramm.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 argc, argv  - Aufrufparameter				   *
*									   *
* r/o globals :								   *
*									   *
* r/w globals :	 siehe load(), mitfn					   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 Errorcode 1 bei Fehlern				   *
*		 Errorcode 0 sonst					   *
*									   *
\**************************************************************************/

main(argc,argv)

int argc;					  /* Aufrufparameter	  */
char *argv[];					  /* werden benutzt	  */

  {
    int	ppos;		      /*   Index '.' in	String			  */



    puts("unido	MIT Compiler Version 1.0");

    if (argc !=	2)				  /* Dateiangabe noetig	  */
      fatal("Usage is 'cmit <MIT-file>'","");
    strcpy(mitfn,*++argv);

    ppos = strlen(mitfn) - 1;		/* MIT-Klartext-Dateinamen bauen  */
    while (    ppos > 0
	    && mitfn[ppos] != '\\'
	    && mitfn[ppos] != '/'
	    && mitfn[ppos] != '.'  ) --ppos;
    if (mitfn[ppos] != '.') strcat (mitfn,".MIT");

    load();					  /* MIT laden/wandeln	  */
    save();					  /* MIT-C-Source	  */
  }





/**************************************************************************\
*									   *
* action      :	 MIT-Klartext laden und	in den MIT-Buffer compilieren.	   *
*		 Programmabbruch mit Meldung bei Fehlern.		   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 (MIBUFSZ, MICOUNT, MIOPNDS)				   *
*									   *
* r/w globals :	 mitbuf, mitidx, mitndx, mitnxt, opnds,	top		   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID load()
  {
    FILE      *mitfile;	      /* Eingabe-MIT-Datei (MIT-Klartext)	  */
    char       str[MAXLINE];  /* Einlesezeile				  */
    char      *cp;	      /* Zeiger	in Einlesezeile			  */
    char      *ptr;	      /* Zeiger	in den MIT-Buffer		  */
    char      *mitend;	      /* ab hier MIT-Buffer-Ueberlauf		  */
    char      *opnd[MIOPNDS]; /* Zeiger	auf Operandenfeld MIT-Buffer	  */
    unsigned   fmt;	      /* Zwischenspeicher Formatfeld		  */
    int	       et;	      /* Ausdruckstyp aus MIT ('p' oder	'x')	  */
    int	       bits;	      /* Anzahl	noch freier Bits in fmt		  */
    int	       ilen;	      /* Code(Instruktions)laenge, 0=1,	1=2, ...  */
    int	       byte;	      /* Codebyte Zwischenspeicher		  */

			      /* im Mnemonic-Teil des MIT-Buffers :	  */
    char   *vptr;	      /*   Zeiger auf Variantenlaengenbyte	  */
    char   *fptr;	      /*   Zeiger auf Formatwort		  */
    char   *last;	      /*   Zeiger auf jeweils letzten Mnemonic	  */

			      /* zur Hashtabellenberechnung :		  */
    int	    h;		      /*   Hashindex				  */
    int	    i;		      /*   Index				  */
    int	    j;		      /*   Index				  */



    if (!(mitfile = fopena(mitfn,"r")))		  /* Inputdatei	oeffnen	  */
      fatal("Unable to open input file:	",mitfn); /* Abbruch bei Fehler	  */
    ptr	= mitbuf;				  /* Anfang MIT-Buffer	  */
    mitend = mitbuf + (MIBUFSZ - MAXLINE);	  /* ab	hier Ueberlauf	  */
    for	(i = 0;	i < MICOUNT; ++i)		  /* Sauberkeit		  */
      mitidx[i]	= EOF;



    /* Operandenfelder laden/compilieren aus MIT-Eingabedatei */

    opnds = 0;				       /* noch kein Operandenfeld */
    while (fgets(str,MAXLINE,mitfile))	       /* alle Operandenfelder	  */
      {
	cp = skip(3,str);		       /* Zeiger auf Op.feld	  */
	if (!isgraph(*cp)) continue;	       /* Zeile	ohne Op.feld	  */
	for (j = 0; j <	opnds; ++j)	       /* Operandenfeld	schon	  */
	  if (sfldcmp(cp,opnd[j]) == 0)	       /* vorhanden ?		  */
	    break;			       /* ja ...		  */
	if (j <	opnds) continue;	       /* ... dann zum naechsten  */
	if (ptr	> mitend)		       /* Buffer-Ueberlauf ?	  */
	  fatal(str,"MIT Buffer	Overflow");    /* ja, Programmabbruch	  */
	opnd[opnds++] =	ptr;		       /* Op.feldzeiger	setzen	  */
	if (opnds == MIOPNDS)		       /* Op.feldueberlauf ?	  */
	  fatal(str,"MIT Operand Overflow");   /* ja, Programmabbruch	  */
	while (isgraph(*ptr = *cp++))	       /* Operandenfeld	kopieren  */
	  ++ptr;
	*ptr++ = '\0';			       /* und mit 0 beenden	  */
      }



    /* Mnemonics und Codefelder	laden/compilieren aus MIT-Datei	*/

    rewind(mitfile);			     /*	ganze Datei noch einmal	  */
    last = ptr;				     /*	letzter	Mnemonic	  */
    *last = '\0';			     /*	haben noch keinen letzten */
    top	= 0;				     /*	noch kein Mnemonic	  */

    while (fgets(str,MAXLINE,mitfile))	     /*	alle  Mnemonics		  */
      {

	if (ptr	> mitend)		     /*	Buffer-Ueberlauf ?	  */
	  fatal(str,"MIT Buffer	Overflow");  /*	ja, Programmabbruch	  */
	if (top	>= MICOUNT)		     /*	Mnemonic-Ueberlauf ?	  */
	  fatal("MIT Mnemonic Overflow",""); /*	ja, Programmabbruch	  */

	cp = skip(2,str);		     /*	Zeiger a. Mnemonic, Input */
	if (fldcmp(cp,last))		     /*	neues Mnemonic ?	  */
	  {				     /*	ja :			  */
	    *ptr++ = 0;			     /*	  voriges abschliessen	  */
	    last = ptr;			     /*	  neues	letztes		  */
	    mitidx[top++]=(int)(ptr-mitbuf); /*	  Index	auf Mnemonic	  */
	    while (isgraph(*ptr	= *cp++))    /*	  Mnemonic kopieren in	  */
	      ++ptr;			     /*	  MIT-Buffer		  */
	    *ptr++ = '\0';		     /*	  und mit 0 abschliessen  */
	  }

	vptr = ptr++;	      /* Zeiger	Variantenlaengenbyte im	Buffer	  */
	*vptr =	2 * INTSZ;    /* initial +-> Operandenindex + Formatwort  */
	cp = skip(3,str);     /* Zeiger	auf Operandenfeld		  */
	if (isgraph(*cp))     /* Operandenfeld vorhanden ?		  */
	  {
	    for	(j = 0;	j < opnds; ++j)		  /* ja	:		  */
	      if (sfldcmp(cp,opnd[j]) == 0)	  /*   selbes Op.feld in  */
		break;				  /*   MIT-Buffer suchen  */
	    if (j == opnds)			  /*   gefunden	?	  */
	      fatal(str,"Can't Find Operand");	  /*   nein - fatal ...	  */
	    putuint(ptr,(int)(opnd[j] -	mitbuf)); /*   Index eintragen	  */
	  }
	else putuint(ptr,-1);		     /*	kein Op.feld :	Index -1  */

	ptr += INTSZ;			     /*	Zeiger in Buffer updaten  */
	fptr = ptr;			     /*	Zeiger Formatfeld im Buf. */
	ptr += INTSZ;			     /*	Zeiger in Buffer updaten  */
	fmt = 0;			     /*	Formatfeldbuffer neu	  */
	bits = 13;			     /*	Anzahl Bits frei in fmt	  */
	ilen = -1;			     /*	Codelaenge neu (0=1, ..	) */
	cp = skip(1,str);		     /*	Zeiger Code-Feld, Input	  */
	while (isgraph(*cp))		     /*	solange	im Codefeld	  */
	  {

	    if (islower(*cp))		     /*	Ausdruck im Codefeld ?	  */
	      {				     /*	ja :			  */
		et = *cp++;		     /*	  Typ merken ('x', 'p')	  */
		bits -=	3;		     /*	  benoetigt 3 Formatbits  */
		fmt = ((fmt >> 3) & 0x1FFF)  /*	  Format rechts	schieben, */
		      +	0x2000;		     /*	  Ausdrucksflagbit dazu	  */
		switch (*cp)		     /*	  8/16-Bit-Ausdruck ?	  */
		   {
		    case '2':		     /*	  ".2" 16-Bit-Ausdruck :  */
		      fmt += 0x8000;	     /*	    16-Bit-Flagbit setzen */
		      ilen += 2;	     /*	    Codelaenge updaten	  */
		    break;

		    case '1':		     /*	  ".1" 8-Bit-Ausdruck :	  */
		      ++ilen;		     /*	    Codelaenge updaten	  */
		    break;

		    default:		     /*	  anderes unbekannt ...	  */
		      fatal(str,"Bad Expression	Specifier");
		    break;
		  }
		if (et == 'p')		     /*	  "p." Ausdruck	PC-rel.	? */
		  fmt += 0x4000;	     /*	  ja, PC-relativ-Flagbit  */
		++cp;			     /*	  nun auf Feldtrenner '_' */
		continue;		     /*	  weiter im Codefeld	  */
	      }	/* end if "Ausdruck im Codefeld" */

	    if (isxdigit(*cp))		     /*	Hexbyte	im Codefeld ?	  */
	      {				     /*	ja :			  */
		if ((j=xtoi(cp,&byte)) > 2)  /*	  Hexbyte holen		  */
		  fatal(str,"Bad Hex Byte"); /*	Abbruch	bei Fehler	  */
		cp += j;		     /*	  Codefeldzeiger updaten  */
		*ptr++ = byte;		     /*	  Byte in MIT-Buffer	  */
		*vptr += 1;		     /*	  Variantenlaenge updaten */
		--bits;			     /*	  benoetigt ein	Formatbit */
		fmt = ((fmt >> 1) & 0x7FFF); /*	  naechstes Formatbit 0	  */
		++ilen;			     /*	  Codelaenge updaten	  */
		continue;		     /*	weiter im Codefeld	  */
	      }	/* end if "Hexbyte im Codefeld"	*/

	    ++cp;			     /*	Feldtrenner '-'	skippen	  */
	  } /* end while "im Codefeld" */

	fmt >>=	bits;			     /*	Formatwort rechtsbuendig  */
	fmt |= ilen & 7;		     /*	Stringlaenge einfuegen	  */
	putuint(fptr,fmt);		     /*	Formatwort eintragen	  */
      }	/* end while "noch Mnemonics da" */
    *ptr++ = 0;				     /*	letzten	Eintrag	beenden	  */



    /* Anzahl Codes / benutzen Speicher	anzeigen */

    printf("  Operation	Codes %5u\n",top);
    printf("Buffer Space Used %5u\n",(unsigned)(ptr - mitbuf));



    /* Hash-Indizes fuer Mnemonics berechnen */

    for(i = 0; i < MICOUNT; ++i)		  /* Reset Hash-Indizes	  */
      mitndx[i]	= mitnxt[i] = EOF;
    for(i = 0; i < top;	++i)			  /* direkte Hash-Indizes */
      {						  /* erzeugen :		  */
	h = hash(mitbuf	+ mitidx[i],MICOUNT);	  /*   wenn Slot frei,	  */
	if (mitndx[h] == EOF) mitndx[h]	= i;	  /*   Index eintragen	  */
      }
    for(i = j =	0; i < top; ++i)		  /* indirekte Hash-Ind.  */
      {						  /* erzeugen		  */
	h = hash(mitbuf	+ mitidx[i],MICOUNT);
	if (mitndx[h] != i)			  /* wenn kein direkter	  */
	  {					  /* Hash vorhanden,	  */
	    while (mitndx[j] !=	EOF)		  /* freien Slot suchen	  */
	      ++j;
	    mitndx[j] =	i;			  /* und Index eintragen  */
	    while (mitnxt[h] !=	EOF)		  /* fuer Index	des Index */
	      h	= mitnxt[h];			  /* freien Slot suchen	  */
	    mitnxt[h] =	j;			  /* und eintragen	  */
	  }
      }



    /* MIT-Datei schliessen */

    fclose(mitfile);
  }





/**************************************************************************\
*									   *
* action      :	 mitbuf, mitidx, mitndx, mitnxt	als C-Source in	die neue   *
*		 Datei TAB.C schreiben.	Abbruch	mit Meldung bei	Fehlern.   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 mitidx, mitndx, mitnxt, mitbuf, opnds,	top		   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID save()
  {
    FILE   *cfile;			/* C-Output-Datei		  */
    int	    n;				/* Index			  */
    int	    oplin;			/* Anzahl Objekte / Zeile	  */
    char   *ptr;			/* Zeiger in MIT-Buffer		  */
    int	    vlen;			/* Variantenlaenge		  */


    if (!(cfile	= fopena("TAB.C","w")))		  /* Sourcedatei anlegen  */
      fatal("Cannot create: ","TAB.C");
    fprintf(cfile,"/* TAB.C with CMIT created from %s */\n\n",mitfn);

    fprintf(cfile,"int mitidx[]	=\n  {");	  /* mitidx schreiben	  */
    for	(n = 0;	n < MICOUNT; ++n)
      {
	if (!(n	% 10)) fprintf(cfile,"\n    ");
	fprintf(cfile,"%5d",mitidx[n]);
	if (n != MICOUNT - 1) fprintf(cfile,",");
      }
    fprintf(cfile,"\n  };\n\n");

    fprintf(cfile,"int mitndx[]	=\n  {");	  /* mitndx schreiben	  */
    for	(n = 0;	n < MICOUNT; ++n)
      {
	if (!(n	% 10)) fprintf(cfile,"\n    ");
	fprintf(cfile,"%5d",mitndx[n]);
	if (n != MICOUNT - 1) fprintf(cfile,",");
      }
    fprintf(cfile,"\n  };\n\n");

    fprintf(cfile,"int mitnxt[]	=\n  {");	  /* mitnxt schreiben	  */
    for	(n = 0;	n < MICOUNT; ++n)
      {
	if (!(n	% 10)) fprintf(cfile,"\n    ");
	fprintf(cfile,"%5d",mitnxt[n]);
	if (n != MICOUNT - 1) fprintf(cfile,",");
      }
    fprintf(cfile,"\n  };\n\n");



    /* mitbuf schreiben	*/

    fprintf(cfile,"char	mitbuf[] =\n  {");

    for	(ptr = mitbuf, n = 0; n	< opnds; ++n)	       /* Operandenfelder */
      {
	oplin =	0;
	while (*ptr)
	  {
	    if (!(oplin++ % 10)) fprintf(cfile,"\n    ");
	    if (*ptr ==	'\'' ||	*ptr ==	'\\')
	      fprintf(cfile,"'\\%c',",*ptr++);
	    else
	      fprintf(cfile," '%c',",*ptr++);
	  }
	if (!(oplin % 10)) fprintf(cfile,"\n	");
	fprintf(cfile,"	  0,");
	++ptr;
      }

    fprintf(cfile,"\n\n	      0,\n");
    ++ptr;

    for	(n = 0;	n < top; ++n)			       /* Mnemonics/Codes */
      {
	oplin =	0;
	while (*ptr)					    /* Mnemonic	  */
	  {
	    if (!(oplin++ % 10)) fprintf(cfile,"\n    ");
	    if (*ptr ==	'\'' ||	*ptr ==	'\\')
	      fprintf(cfile,"'\\%c',",*ptr++);
	    else
	      fprintf(cfile," '%c',",*ptr++);
	   }
	if (!(oplin % 10)) fprintf(cfile,"\n	");
	fprintf(cfile,"	  0,");
	++ptr;
	while (*ptr)				       /* alle Varianten  */
	  {
	    vlen = *ptr++ & 0xFF;			    /* Variante	  */
	    fprintf(cfile,"\n	 %4d,",vlen);
	    oplin = 1;
	    while (vlen--)
	      {
		if (!(oplin++ %	10)) fprintf(cfile,"\n	  ");
		fprintf(cfile,"0x%02x,",*ptr++ & 0xFF);
	      }
	  }
	if (!(oplin % 10)) fprintf(cfile,"\n	");
	fprintf(cfile,"	  0");
	if (n != top - 1) fprintf(cfile,",");
	++ptr;
      }

    fprintf(cfile,"\n  };\n\n");



    fprintf(cfile,"\n\n/* end of TAB.C */\n");	       /* Datei	beenden	  */
    if (ferror(cfile))				       /* Fehlertest	  */
      fatal("Write Error on: ","TAB.C");
    fclose(cfile);				       /* und schliessen  */
  }





/**************************************************************************\
*									   *
* action      :	 Stringfelder vergleichen.				   *
*									   *
*		 Feld =	durch String/Zeilenende	oder isspace-Zeichen	   *
*			beendetes Feld in einem	String			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 s	-  Zeiger auf erstes Feld			   *
*		 t	-  Zeiger auf zweites Feld			   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 < 0  wenn  s <	t					   *
*		   0  wenn  s =	t					   *
*		 > 0  wenn  s >	t					   *
*									   *
\**************************************************************************/

sfldcmp(s,t)

char *s;
char *t;

  {
    while (*s == *t)
      {
	if (!isgraph(*s)) return (0);
	++s;
	++t;
      }
    if ((isspace(*s) ||	atend(*s)) && (isspace(*t) || atend(*t)))
      return (0);
    return (*s - *t);
  }



/* Ende	von CMIT.C */
