/**************************************************************************\
*									   *
*   MAC2.C   -	 unido X-Mac, Teil 2 von 5				   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <string.h>			/* Stringfunktionen benutzt	  */
#include <ctype.h>
#include "all.h"			/* allgemeine Festlegungen	  */
#include "mac.h"			/* Festlegungen	fuer MAC	  */
#include "mace.h"			/* Externals MAC		  */
#include "rel.h"			/* Aufbau REL			  */
#include "uti.h"
#include "rele.h"			/* Externals REL.C		  */

/*------------------------------------------------------------------------*/
/*---  Prototypen der verwendeten nicht-integer	Funktionen	       ---*/
/*------------------------------------------------------------------------*/
void symerr __ARGS((void));
void parerr __ARGS((void));
void outerr __ARGS((char *));


/**************************************************************************\
*									   *
* action      :	 Abfrage, ob noch need Zeichen in eine Textzeile passen,   *
*		 in der	schon i	- 1 Zeichen (i Index in	Zeile) stehen.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 i	-  aktueller Index in Zeile			   *
*		 need	-  Anzahl Zeichen, die noch in Zeile geschrieben   *
*			   werden sollen				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 YES - need Zeichen passen noch	in die Zeile		   *
*		 NO  - sonst						   *
*									   *
\**************************************************************************/

int cantake(i,need)

int i;
int need;

  {
    return (i <	(MAXLINE - 3) -	need);
  }





/**************************************************************************\
*									   *
* action      :	 Zeile aus dem Makropuffer (mtptr) holen in line.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 line	-  globale aktuelle Sourcezeile			   *
*		 mtptr	-  Eingang: Zeiger auf zu kopierende Makrozeile	   *
*			   Ausgang: Zeiger hinter  "  "	 "		   *
*									   *
* locals      :	 cp	-  Zeiger in line				   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID getmac()
  {
    char *cp;

    cp = line;
    while ((*cp++ = *mtptr++) != 0x00) ;
  }





/**************************************************************************\
*									   *
* action      :	 Makrooperationen ab lp	erkennen und zurueckgeben.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 lp	  -  Stringzeiger auf zu untersuchendes	Symbol	   *
*		 expmode  -  wenn != 0,	dann innerhalb Makroexpansion	   *
*		 defmode  -  wenn != 0,	dann innerhalb Makrodefinition	   *
*		 reptmode -  wenn != 0,	dann innerhalb REPT		   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 MACRO - wenn Symbol ab	lp MACRO ist			   *
*		 REPT  - wenn Symbol ab	lp REPT	ist und	nicht reptmode	   *
*		 ENDM  - wenn Symbol ab	lp ENDM	ist			   *
*		 CALL  - wenn Symbol in	Makrotabelle gefunden und nicht	   *
*			 Definitions- oder Expansionsmodus an		   *
*		 NO    - sonst						   *
*									   *
\**************************************************************************/

int macop()
  {
    if (fldcmp(lp,"ENDM" ) == 0) return	(ENDM);
    if (fldcmp(lp,"MACRO") == 0) return	(MACRO);
    if (fldcmp(lp,"REPT" ) == 0)
      if (reptmode)
	return (NO);
      else
	return (REPT);
    if (!expmode && !defmode &&	mtfind()) return (CALL);
    return (NO);
  }





/**************************************************************************\
*									   *
* action      :	 Testet, ob ab ptr noch	eine Zeile in den Makrobuffer	   *
*		 passt.	Wenn nicht, dann Programmabbruch mit		   *
*		 entsprechender	Meldung.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 ptr	-  Zeiger auf Stelle im	Makrobuffer, ab	der eine   *
*			   eine	Zeile hineinkopiert werden soll		   *
*									   *
* r/o globals :	 mtend	-  Zeiger auf Stelle im	Makrobuffer, ab	der noch   *
*			   hoechstens eine Zeile in diesen hineinpasst	   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID macover(ptr)

char *ptr;

  {
    if (ptr > mtend) fatal("Macro Buffer overflow", "");
  }





/**************************************************************************\
*									   *
* action      :	 Untersuchen, ob das Symbol, auf das lp	in der Sourcezeile *
*		 zeigt,	ein in der Makrotabelle	mt eingetragener Makro	   *
*		 ist. Wenn ja, zeigt mtptr auf die erste Zeile in diesem   *
*		 Makro.							   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 mt	-  Anfang der Makrotabelle			   *
*		 lp	-  Zeiger auf zu untersuchendes	Symbol in Source-  *
*			   zeile					   *
*									   *
* r/w globals :	 mtptr	-  Zeiger in mt, wenn Makro gefunden, dann bei	   *
*			   Ausgang Zeiger auf 1. Zeile der Makrodefinition *
*									   *
* locals      :	 mtidx	-  Index in mt auf den Anfang der jeweils	   *
*			   naechsten Makrodefinition			   *
*									   *
* returns     :	 YES - Makro, auf den lp zeigt,	gefunden in mt		   *
*		 NO  - sonst						   *
*									   *
\**************************************************************************/

BOOLEAN	mtfind()
  {
    int	mtidx;

    if (!atend(*lp))				  /* Sourcezeilenende ?	  */
      {						  /* nein,		  */
	mtptr =	mt;				  /* Makrotabelle ganz	  */
	do					  /* durchgucken	  */
	  {
	    if (fldcmp(lp,mtptr	+ MTNAM) == 0)	  /* lp	zeigt auf Makro	! */
	      {
		mtptr += MTNAM;			  /* mtptr zeigt auf 1.	  */
		mtptr += strlen(mtptr) + 1;	  /* Zeile des Makros	  */
		return (YES);			  /* gefunden !		  */
	      }
	    mtidx = getuint(mtptr);		  /* nicht gefunden,	  */
	    mtptr = mt + mtidx;			  /* Zeiger auf	naechsten */
	  }					  /* solange noch Makro-  */
	while (mtidx);				  /* defs da		  */
      }
    return (NO);				  /* Makro nicht gefunden */
  }





/**************************************************************************\
*									   *
* action      :	 Neuen Makro mit durch getsy() geholten	Namen anlegen.	   *
*									   *
*		 Pruefen, ob noch fuer mindestens eine Zeile Platz im	   *
*		 Makrobuffer ist. Wenn nicht, Programmabbruch mit	   *
*		 entsprechender	Meldung.				   *
*									   *
*		 An naechster freien Stelle im Makrobuffer neuen Makro	   *
*		 anlegen. Im neuen Makro Index auf naechsten loeschen,	   *
*		 Im vorherigen Makro diesen Index auf den neuen	Makro	   *
*		 setzen. Makronamen aus	stsym in den Makrobuffer kopieren. *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 stsym	-  enthaelt Namen des neuen Makros nullterminiert  *
*		 gotnam	-  Symbolfehler, wenn == 0			   *
*		 badsym	-  Symbolfehler, wenn != 0			   *
*									   *
* r/w globals :	 mtnext	-  Eingang: Index auf mt, naechste freie Stelle	   *
*			   Ausgang: Index auf mt, zeigt	hinter die 0 des   *
*				    neuen Makronamens			   *
*		 mtprev	-  Eingang: Index auf mt, zeigt	auf Anfang des	   *
*				    letzten gueltigen Makros		   *
*			   Ausgang: Index auf mt, zeigt	auf Anfang des	   *
*				    neuen Makros			   *
*									   *
* locals      :	 i	-  Index in stsym				   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID newmac()
  {
    int	i;

    i =	0;				     /*	Startindex stsym	  */
    if (!gotnam	|| badsym)		     /*	falls Fehler im	Symbol,	  */
      symerr();				     /*	dies melden		  */
    else
      {
	macover(mtnext);		     /*	noch mind. 1 Zeile Platz  */
	if (mtprev)			     /*	Index auf neuen	Makro in  */
	  putuint(mtprev,(unsigned)(mtnext - mt)); /* letzten eintragen	  */
	mtprev = mtnext;		     /*	Index letzter =	neuer	  */
	putuint(mtnext,0);		     /*	Tabellenende bei neuem	  */
	mtnext += INTSZ;		     /*	Makroname ab hier	  */
	while ((*mtnext++ = stsym[i++])	!= 0x00) ;
					     /*	 " mit 0 am Ende kopieren */
      }
  }





/**************************************************************************\
*									   *
* action      :	 Aktuelle Sourcezeile line in den Makrobuffer uebertragen  *
*		 einschliesslich des abschliessenden Nullbytes.		   *
*									   *
*		 Pruefen, ob noch fuer mindestens eine Zeile Platz im	   *
*		 Makrobuffer ist. Wenn nicht, Programmabbruch mit	   *
*		 entsprechender	Meldung.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 mtnext	-  ab hier Zeile ablegen, zeigt	nach Kopieren	   *
*			   hinter die 0	der Zeile auf die naechste freie   *
*			   Stelle im Makrobuffer			   *
*									   *
* locals      :	 cp	-  Kopierzeiger	in line				   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID putmac()
  {
    char *cp;

    cp = line;			   /* Kopierzeiger setzen		  */
    macover(mtnext);		   /* passt mind. 1 Zeile in Makrobuf. ?  */
    while ((*mtnext++ =	*cp++) != 0x00)	;
				   /* line einschliesslich Ende	in Buffer */
  }





/**************************************************************************\
*									   *
* action      :	 Aufrufparameter des Makros aus	Eingabezeile in		   *
*		 Makrotextbuffer uebertragen, jeder Parameter als	   *
*		 nullterminierter String. Bei Rueckgabe	zeigt jeder	   *
*		 Eintrag in mpptr auf den Anfang des entsprechenden	   *
*		 Parameterstrings im Makrotextbuffer oder ist		   *
*		 NULL, wenn kein entsprechender	Parameter vorhanden ist.   *
*		 Strings ("..",'..') als Parameter werden ohne Delimiter   *
*		 abgelegt. Alle	Eintraege im Makrolabelbuffer mlnbr[]	   *
*		 werden	auf 0 gesetzt.					   *
*									   *
*		 Bei Ueberlauf des Makrotextbuffers oder bei zu	vielen	   *
*		 Makroparametern werden	die entsprechenden Fehlerflags	   *
*		 gesetzt.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 mtnext	  -  Basis Freiplatz im	Makrotextbuffer		   *
*									   *
* r/w globals :	 lp	  -  bei Aufruf	Zeiger auf Makroaufruf,	danach	   *
*			     Zeiger in Makroparameterstring		   *
*		 mlnbr[]  -  alle Eintraege 0				   *
*		 mpptr[]  -  fuer jeden	Parameter Zeiger in auf	in Makro-  *
*			     textbuffer	uebertragenen Parameterstring oder *
*			     NULL, wenn	Parameter nicht	vorhanden	   *
*									   *
* locals      :	 i	  -  Makroparameterindex (0..9)			   *
*		 dlm	  -  Delimiterzeichen, wenn Parameter String	   *
*		 cp	  -  Zeiger in Makrotextbuffer			   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID putparm()
  {
    int	    i;
    int	    dlm;
    char   *cp;

    i =	-1;			   /* 1. while-Durchlauf i == 0		  */
    cp = mtnext;		   /* Basis Freiplatz in Makrotextbuffer  */
    lp = skip(2,lp);		   /* auf Makroparameter positionieren	  */
    while (++i < 10)		   /* immer fuer 10 Parameter		  */
      {
	mlnbr[i] = 0;			/* Makrolabelnummer loeschen	  */
	while (isspace(*lp)) ++lp;	/* auf naechsten Parameter	  */
	if (atend(*lp) || *lp == ',')	/* wenn	Zeilenende oder	','	  */
	  mpptr[i] = NULL;		/* dann	Parameterzeiger	leer	  */
	else				/* sonst Textbuffer checken, ob	  */
	  {
	    macover(cp);			  /* genug Platz	  */
	    mpptr[i] = cp;			  /* Parameterzeiger	  */
	    while (!atend(*lp) && *lp != ',')	  /* Parameter in Textbuf */
	      {					  /* uebertragen	  */
		if (*lp	== '\"'	|| *lp == '\'')	  /* wenn String dann	  */
		  {				  /* Delimiter nicht	  */
		    dlm	= *lp;			  /* uebertragen, aber	  */
		    while (!atend(*++lp))	  /* den String	selbst	  */
		      {
			if (*lp	== dlm && *++lp	!= dlm)	break;
			*cp++ =	*lp;
		      }
		  }
		else
		  *cp++	= *lp++;
	      }
	    *cp++ = '\0';		/* Parameterstring beenden	  */
	  }
	if (*lp	== ',')	++lp;		/* Komma in Zeile ueberspringen	  */
      }	/* end while (i++ < 10)	*/
    if (!atend(*lp)) parerr();		/* > 10	Parameter -> Fehler	  */
  }





/**************************************************************************\
*									   *
* action      :	 Parameter und Makrolabels in Makrozeile ersetzen. In der  *
*		 Eingabezeile line werden alle Makroparameter ersetzt und  *
*		 alle lokalen Makrolabel in reale Label	expandiert.	   *
*									   *
*		 Die Laenge von	line wird bei jeder Expansion ueberprueft. *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 mpptr[]  -  Zeiger auf	die Makroparameterstrings ab	   *
*			     mtnext					   *
*									   *
* r/w globals :	 line[]	  -  bei Eingang die aktuelle Eingabezeile, bei	   *
*			     Ausgabe Eingabezeile, alle	Makroparameter	   *
*			     expandiert, alle Makrolabels in reale Labels  *
*			     expandiert					   *
*		 mlnbr[]  -  Makrolabelnummernspeicher,	bei jedem ersten   *
*			     Auftreten wird dem	Makrolabel entsprechend	   *
*			     mlnbr[Makrolabelnummer] auf mlnext	gesetzt	   *
*		 mlnext	  -  Nummer, die die naechste Makrolabelnummer	   *
*			     ersetzt, wird bei jeder Zuweisung erhoeht	   *
*									   *
* locals      :	 lin[]	  -  lokaler Buffer fuer Eingabezeile line	   *
*		 ndx	  -  Index in mpptr[] (Makroparameter) oder	   *
*			     mlnbr[] (Makrolabel)			   *
*		 cp	  -  Zeiger in lin				   *
*		 cp2	  -  Zeiger in Parameterstring im Makrotextbuffer  *
*		 i	  -  Index in line				   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID replace()
  {
    char    lin[MAXLINE];
    int	    ndx;
    char   *cp;
    char   *cp2;
    int	    i;

    strcpy(lin,line);			/* line	kopieren		  */
    cp = lin;				/* cp initialisieren, 1. Zeichen  */
    i =	0;				/* line-Index, 1. Zeichen	  */
    do					/* fuer	die ganze Eingabezeile	  */
      {
	if (*cp	== '?')			/* Parameterersetzungsmarker ?	  */
	  {				/* ja,				  */
	    if (isdigit(*++cp))		/* Parameterersetzung ?		  */
	      {				/* ja,				  */
		ndx = *cp++ - '0' - 1;	/* Index in mpptr berechnen,	  */
		if (ndx	< 0) ndx = 9;	/* 0 bedeutet 10		  */
		if ((cp2 = mpptr[ndx]) != 0x00)
					/* Parameter nicht leer	?	  */
		  {			/* ja, in line kopieren, Laenge	  */
		    while (*cp2)	/* checken			  */
		      if (cantake(i,1))
			line[i++] = *cp2++;
		  }
		continue;
	      }
	  }
	if (*cp	== '@')			/* Labelersetzung ?		  */
	  {				/* ja,				  */
	    if (cantake(i,1))		/* Labelmarker einfuegen	  */
	      line[i++]	= '@';
	    if (isdigit(*++cp))		/* Labelnummer dahinter	?	  */
	      {				/* ja,				  */
		ndx = *cp++ - '0';	/* Nummer holen, ist Index	  */
		if (!mlnbr[ndx])	/* falls erstes	Erscheinen,	  */
		  mlnbr[ndx]= ++mlnext;	/* reale Nummer	zuordnen	  */
		if (cantake(i,5))	/* reale Nummer	in String wandeln */
		  {			/* und in line einfuegen	  */
		    left(itou(mlnbr[ndx],line +	i,5));
		    while (line[i]) ++i;
		  }
		continue;
	      }
	  }
	if (cantake(i,1))		/* alten line-Inhalt ausser	  */
	  line[i++] = *cp++;		/* Parametern zeichenweise	  */
	else				/* kopieren,			  */
	  {				/* bei Ueberlauf CR einfuegen	  */
	    line[i++] =	'\n';
	    break;
	  }
      }
    while (*cp);			/* bis Eingabezeile zuende	  */
    line[i] = '\0';			/* Zeilenende setzen		  */
  }





/**************************************************************************\
*									   *
* action      :	 Zeile im Listing einleiten. Wenn Listing gewuenscht ist   *
*		 und Pass 2, auf neue Seite testen und ggf. neue Seite	   *
*		 mit Ueberschrift einleiten. Zeile einleiten, Zeilennummer *
*		 im Listing und	aktuellen Programmzaehler ausgeben, Typ	   *
*		 des Zaehlers ausgeben.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 pass	-  nur wenn 2 Listing				   *
*		 list	-  YES:	Listing	ausgeben			   *
*		 seg	-  aktuelles Segment (DREL/PREL)		   *
*		 lin	-  aktuelle Listingzeile			   *
*		 loc	-  aktueller Programmzaehlerstand		   *
*									   *
* r/w globals :	 lline	-  aktuelle Zeile/Seite				   *
*		 ccnt	-  aktuelles Zeichen/Zeile nach	lin/loc-Ausgabe	   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID begline()
  {
    if (pass ==	2 && list)			  /* Listing ?		  */
      {
	if (begpage())				  /* neue Seite	?	  */
	  {
	    puts(" line	loc   ----object----  source\n");   /* ja ...	  */
	    lline += 3;
	  }
	printf("%5d %04x",lin,loc);		  /* Zeile einleiten	  */
	switch (seg)
	  {
	    case PREL :	  fputs("' ",stdout);	 break;
	    case DREL :	  fputs("\" ",stdout);	 break;
	    default   :	  fputs("  ",stdout);	 break;
	  }
	ccnt = 0;
	++lline;
      }
  }





/**************************************************************************\
*									   *
* action      :	 Ausfuehren eines Beginns einer	neuen Seite, wenn die	   *
*		 aktuelle Zeilennummer lline der aktuellen Seite lpage	   *
*		 groesser gleich 58 ist.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 srcfn	-  Name	der Sourcedatei				   *
*									   *
* r/w globals :	 lline	-  aktuelle Zeilennummer auf der aktuellen Seite   *
*			   = 2 nach Beginn einer neuen Seite		   *
*		 lpage	-  akuelle Seitennummer				   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 YES - eine neue Seite wurde begonnen			   *
*		 NO  - sonst						   *
*									   *
\**************************************************************************/

BOOLEAN	begpage()
  {
    if (lline >= 58)				       /* neue Seite ?	  */
      {
	lline =	2;				       /* ja - naechste	  */
	++lpage;				       /* Zeile	/ Seite	  */
	if (lpage > 1) puts("\n\n\n\n\n\n\n");	       /* altes	S.-Ende	  */
	printf("Z80 Crossassembler   -   ");	       /* Ueberschrift	  */
	printf("file: %s   page: %d\n\n",srcfn,lpage); /* neue Seite	  */
	return (YES);				       /* neue begonnen	! */
      }
    return (NO);				       /* keine	neue S.	  */
  }





/**************************************************************************\
*									   *
* action      :	 Zeile im Listing abschliessen wenn Pass 2 und Listing	   *
*		 gewuenscht. Wenn part1	== YES,	CR/LF ausgeben.		   *
*		 Wenn part1 == NO, dann	mit Spaces formatieren bis	   *
*		 ccnt == 16, dann Zeile	aus Eingabezeile line ausgeben,	   *
*		 TAB's expandieren, part1 = YES.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 pass	-  nur wenn 2 Listing				   *
*		 list	-  YES:	Listing	ausgeben			   *
*		 line	-  aktuelle zu assemblierende Eingabezeile	   *
*									   *
* r/w globals :	 ccnt	-  Zeichen/Zeile nach lin/loc-Ausgabe		   *
*									   *
* locals      :	 cp	-  Zeiger in line				   *
*		 col	-  Spaltenzaehler fuer TAB-Expansion		   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID endline()
  {
    char   *cp;
    int	    col;

    col	= 0;					  /* 1.	TAB-Stelle	  */
    if (pass ==	2 && list)			  /* Listing ?		  */
      {
	if (part1)				  /* Zeile schon fertig	? */
	  puts("");				  /* ja, nur CR/LF	  */
	else					  /* nein,		  */
	  {
	    part1 = YES;			  /* Ausgabe merken	  */
	    while (ccnt++ < 16)	putchar(' ');	  /* formatieren	  */
	    cp = line;				  /* Eingabezeile	  */
	    while (*cp)				  /* ausgeben,		  */
	      {
		if (*cp	!= '\t')
		  {
		    ++col;
		    putchar(*cp++);
		  }
		else				  /* TAB's expandieren	  */
		  {
		    do
		      putchar(' ');
		    while (++col % 8);
		    cp++;
		  }
	      }	/* end while (*cp) */
	  } /* end else	from if	(part1)	*/
      }	/* end if (pass	== 2 &&	list) */
  }





/**************************************************************************\
*									   *
* action      :	 Ausgabe einer Fehlermeldung entsprechend lerr.		   *
*		 Wenn Listing nicht eingeschaltet ist, dann die		   *
*		 zugehoerige Sourcezeile auch ausgeben.			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 lerr  -  Flag,	ob und welche Fehler sich in der aktuellen *
*			  Zeile	ergeben	haben				   *
*		 list  -  YES: Listing wird erstellt, NO sonst		   *
*		 line  -  aktuelle Sourcezeile				   *
*									   *
* r/w globals :	 err   -  Flag,	dass sich Fehler ereignet haben, wird auf  *
*			  YES gesetzt, wenn lerr Fehler	anzeigt		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID gripe()
  {
    if (lerr)
      {
	if (!list) outerr(line);
	if (lerr & 0x0001) outerr("- Backward Movement\n");
	if (lerr & 0x0002) outerr("- Bad Number\n");
	if (lerr & 0x0004) outerr("- Bad Expression\n");
	if (lerr & 0x0008) outerr("- Bad Label\n");
	if (lerr & 0x0010) outerr("- Bad Operation\n");
	if (lerr & 0x0020) outerr("- Redundant Definition\n");
	if (lerr & 0x0040) outerr("- Bad Symbol\n");
	if (lerr & 0x0080) outerr("- Relocation	Error\n");
	if (lerr & 0x0100) outerr("- Undefined Symbol\n");
	if (lerr & 0x0200) outerr("- Bad Parameter\n");
	if (lerr & 0x0400) outerr("- Range Error\n");
	outerr("\n");
	err = YES;
      }
  }





/**************************************************************************\
*									   *
* action      :	 Fehlertyp fuer	aktuelle Zeile in lerr merken,		   *
*		 Aufschluesselung lerr siehe gripe().			   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 lerr  -  Merker fuer Fehlerart	in Zeile		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID bakerr()	{ lerr |= 0x0001; }
VOID numerr()	{ lerr |= 0x0002; }
VOID experr()	{ lerr |= 0x0004; }
VOID laberr()	{ lerr |= 0x0008; }
VOID oprerr()	{ lerr |= 0x0010; }
VOID rederr()	{ lerr |= 0x0020; }
VOID symerr()	{ lerr |= 0x0040; }
VOID relerr()	{ lerr |= 0x0080; }
VOID underr()	{ lerr |= 0x0100; }
VOID parerr()	{ lerr |= 0x0200; }
VOID rngerr()	{ lerr |= 0x0400; }





/**************************************************************************\
*									   *
* action      :	 Codebestandteil im Listing ausgeben. Wenn Listing	   *
*		 gewuenscht Byte (sz = 1) oder Word (sz	= 2) aus field	   *
*		 ASCII mit fuehrenden Nullen ausgeben, Suffix suff direkt  *
*		 folgend ausgeben, ccnt	aktualisieren. Vor der Ausgabe	   *
*		 wird geprueft,	ob die Ausgabe in das Codefeld passt, wenn *
*		 nicht,	wird die letzte	Zeile beendet und eine neue Zeile  *
*		 wird begonnen.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 sz	-  1 = Byte auszugeben aus field		   *
*			   2 = Word auszugeben aus field		   *
*		 suff	-  nullterminierter String, hinter der Ausgabe von *
*			   field auszugeben				   *
*									   *
* r/o globals :	 field	-  enthaelt auszugebenden Wert,	Byte oder Word	   *
*		 list	-  YES:	Listing	ausgeben			   *
*									   *
* r/w globals :	 ccnt	-  Zeichen/Zeile nach lin/loc-Ausgabe		   *
*									   *
* locals      :	 i	-  Anzahl Zeichen auszugeben/gegeben		   *
*		 str	-  Zeichenbuffer fuer Umwandlung Byte -> ASCII	   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID listcode(sz,suff)

int    sz;
char   suff[];

  {
    int	   i;
    char   str[3];

    if (list)					  /* Listing ?		  */
      {
	i = sz + sz + strlen(suff);		  /* Laenge der	Ausgabe	  */
	if ((ccnt + i) > 16)			  /* falls zu lang, in	  */
	  {					  /* naechste Zeile	  */
	    endline();
	    begline();
	  }
	while (sz--)				  /* Byte oder Word aus	  */
	  {					  /* field ausgeben	  */
	    if (sz)				  /* Word :		  */
	      itox((field >> 8)	& 0xFF,str,3);	  /* high Byte		  */
	    else
	      itox(field & 0xFF,str,3);		  /* Byte oder low Byte	  */
	    if (*str ==	' ') *str = '0';	  /* fuehrende Null	  */
	    fputs(str,stdout);			  /* Ausgabe		  */
	  }
	fputs(suff,stdout);			  /* Suffix anhaengen	  */
	ccnt +=	i;				  /* Ausgabelaenge	  */
      }
  }





/**************************************************************************\
*									   *
* action      :	 Fehlerzeile str ausgeben.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 str	-  Zeiger auf die CR enthaltende auszugebende	   *
*			   Fehlermeldung				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 lline	-  Nummer der aktuellen	Zeile auf der aktuellen	   *
*			   Seite im Listing				   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID outerr(str)

char *str;

  {
    begpage();			       /* ggf. neue Seite beginnen	  */
    fputs(str,stdout);		       /* Meldung ausgeben		  */
    ++lline;			       /* eine Zeile weiter auf	der Seite */
  }



/* Ende	von MAC2.C */
