/**************************************************************************\
*									   *
*   MAC4.C   -	  unido	X-Mac, Teil 4 von 5				   *
*									   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/*							       Includes	  */
/**************************************************************************/

#include <stdio.h>			/* Standardausgabe benutzt	  */
#include <string.h>			/* Stringfunktionen benutzt	  */
#include <ctype.h>
#include "all.h"			/* allgemeine Festlegungen	  */
#include "mac.h"			/* Festlegungen	fuer MAC	  */
#include "mace.h"			/* Externals MAC		  */
#include "rel.h"			/* Aufbau REL			  */
#include "uti.h"
#include "rele.h"			/* Externals REL.C		  */


/*------------------------------------------------------------------------*/
/*---  Prototypen der verwendeten nicht-integer	Funktionen	       ---*/
/*------------------------------------------------------------------------*/
void shell __ARGS((int, int));
void show __ARGS((char *));


/**************************************************************************\
*									   *
* action      :	 Code listen und generieren.				   *
*									   *
*		 Byte (sz = 1) oder Word (sz = 2) aus field absolut in	   *
*		 REL-Ausgabefile schreiben.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 sz	-  1: Byte generieren				   *
*			   2: Word generieren				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 field	-  Wert	fuer Generierung			   *
*		 loc	-  += sz					   *
*		 item	-  ABS						   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID genabs(sz)

int sz;

  {
    listcode(sz," ");			/* Code	listen			  */
    loc	+= sz;				/* Positionszaehler erhoehen	  */
    item = ABS;				/* und schreiben, absolut	  */
    while (sz--)			/* ein-	oder 2 Byte,		  */
      {					/* bei 2 Byte low Byte / high	  */
	putrel();			/* Byte	Reihenfolge		  */
	field >>= 8;
      }
  }





/**************************************************************************\
*									   *
* action      :	 Code listen und generieren.				   *
*									   *
*		 Relokatiblen Wert aus field vom Typ it	(nur PREL/DREL)	   *
*		 in REL-Ausgabefile schreiben.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 it	  -  Typ von field				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 (field)  -  Wert fuer Generierung			   *
*		 loc	  -  +=	2					   *
*		 item	  -  RELBITS aus it				   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID genrel(it)
int it;
  {
    it &= RELBITS;				  /* nur RELBITS relevant */
    switch (it)					  /* Code listen	  */
      {
	case PREL :  listcode(2,"' ");	  break;
	case DREL :  listcode(2,"\" ");	  break;
      }
    loc	+= 2;			   /* Positionszaehler			  */
    item = it;			   /* Typ zum Schreiben			  */
    putrel();			   /* 2	Byte langer relokatiblen Eintrag  */
  }





/**************************************************************************\
*									   *
* action      :	 Code generieren.					   *
*									   *
*		 Modul-	und Dateiende in REL-Ausgabefile schreiben.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 endt	-  Modulende, Typ (PREL)			   *
*		 endv	-  Modulende, Wert (Programmstart)		   *
*									   *
* r/w globals :	 field	-  Wert	fuer Generierung			   *
*		 type	-  Typ fuer Generierung				   *
*		 item	-  EPROG/EFILE					   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID putend()
  {
    item = EPROG;					    /* Modulende  */
    type = endt;
    field = endv;
    putrel();
    item = EFILE;					    /* Dateiende  */
    type = ABS;
    field = 0;
    putrel();
  }





/**************************************************************************\
*									   *
* action      :	 Code generieren.					   *
*									   *
*		 Einsprungpunkte ungeordnet ohne Werte in REL-Ausgabefile  *
*		 schreiben, Typ	ENAME.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 st	-  Anfang Symboltabelle				   *
*		 stend	-  letzter Eintrag + 1 in Symboltabelle		   *
*									   *
* r/w globals :	 item	-  ENAME					   *
*		 symbol	-  Einsprungpunktnamensspeicher			   *
*									   *
* locals      :	 cp	-  Zeiger in Symboltabelle			   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID putent()
  {
    char *cp;

    cp = st;				/* 1. Eintrag Symboltabelle	  */
    while (cp <	stend)			/* alle	Eintraege durchgucken	  */
      {
	if (*cp)				  /* Eintrag belegt	  */
	  {
	    if (cp[STFLAG] & EPBIT)		  /* mit Einsprungpunkt	? */
	      {
		item = ENAME;			  /* ja, Einsprungpunkts- */
		strncpy(symbol,cp,MAXSYM + 1);	  /* Namen holen und	  */
		putrel();			  /* schreiben		  */
	      }
	  }
	cp += STENTRY;				  /* zum naechsten	  */
      }
  }





/**************************************************************************\
*									   *
* action      :	 Code generieren.					   *
*									   *
*		 Einsprungpunkt	oder externe Referenz in REL-Ausgabefile   *
*		 schreiben.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 cp	-  Zeiger auf Symboltabelleneintrag		   *
*			   (Einsprungpunkt oder	externe	Referenz)	   *
*		 i	-  zu schreibender Itemcode			   *
*			   (Einsprungpunkt oder	externe	Referenz)	   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 item	-  i						   *
*		 type	-  Typ aus Symboltabelleneintrag		   *
*		 field	-  Wert	aus Symboltabelleneintrag		   *
*		 symbol	-  Name	aus Symboltabelleneintrag		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID putex(cp, i)
char *cp;
int i;
  {
    item = i;				/* Einsprungpunkt oder ext. Ref.  */
    type = cp[STFLAG] &	RELBITS;	/* Typ,	nur RELBITS		  */
    field = getuint(cp + STVALUE);	/* Wert				  */
    strncpy(symbol,cp,MAXSYM + 1);	/* Name, max. Anzahl Stellen	  */
    putrel();				/* Eintrag schreiben		  */
  }





/**************************************************************************\
*									   *
* action      :	 Code listen und generieren.				   *
*									   *
*		 Symboltabelle nach Namen sortieren. Alle Einsprungpunkte  *
*		 und externe Referenzen	in REL-Ausgabefile schreiben.	   *
*		 Symboltabelle ausgeben, wenn Listing gewuenscht.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 stn	-  Anzahl Symbole in Symboltabelle		   *
*		 list	-  YES:	Listing	gewuenscht			   *
*		 stp[]	-  Zeigerliste Symboltabelle			   *
*									   *
* r/w globals :	 ccnt	-  Anzahl Zeichen ausgegeben / Zeile		   *
*		 lline	-  Anzahl Zeilen / Seite			   *
*									   *
* locals      :	 i	-  Index stp[]					   *
*		 cp	-  Zeiger in Symboltabelle			   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID putexs()
  {
    int	    i;
    char   *cp;

    ccnt = 0;
    shell(0,stn	- 1);				  /* Symbole sortieren	  */

    if (list)					  /* Listing :		  */
      {						  /* Ueberschrift fuer	  */
	lline += 4;				  /* Symboltabelle	  */
	if (!begpage())
	  puts("\n");
	else
	  lline	+= 2;
	puts("symbols:\n");
      }

    for	(i = 0;	i < stn; ++i)			  /* fuer alle Symbole	  */
      {
	cp = stp[i];
	if (list) show(cp);			  /* Symbol listen	  */
	if (cp[STFLAG] & XRBIT)	putex(cp,XCHAIN); /* ext. Ref. schreiben  */
	if (cp[STFLAG] & EPBIT)	putex(cp,EPOINT); /* Entrypoint	schreiben */
      }
    if (list) puts("");				  /* Listing beenden	  */
  }





/**************************************************************************\
*									   *
* action      :	 Code generieren.					   *
*									   *
*		 Modulnamen aus	objfn aufbauen und in REL-Ausgabefile	   *
*		 schreiben.						   *
*									   *
*									   *
*		 ACHTUNG: Nur Dateinamen des Aufbaus			   *
*									   *
*			    [<drive>:]<name>[.<ext>]			   *
*									   *
*			  werden unterstuetzt !				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 objfn[]   -  Dateiname	der Objektdatei			   *
*									   *
* r/w globals :	 symbol[]  -  Symbol fuer REL-Ausgabe			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID putname()
  {
    int	i;				/* Index in objfn[]		  */
    int	j;				/* Index in symbol[]		  */

    item = PNAME;			/* Modulname wird geschrieben	  */
    if (objfn[1] == ':')		/* Drivespec ueberspringen	  */
      i	= 2;
    else
      i	= 0;
    j =	0;
    while (objfn[i] && objfn[i]	!= '.' && j < MAXSYM)  /* <name> kopieren */
      symbol[j++] = objfn[i++];			       /* max. MAXSYM Z.  */
    symbol[j] =	'\0';				       /* Stringende	  */
    putrel();					       /* Symbol schr.	  */
  }





/**************************************************************************\
*									   *
* action      :	 Code generieren.					   *
*									   *
*		 Programm- und Datenbereichsgroesse in REL-Ausgabedatei	   *
*		 schreiben.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 loc	 -  aktueller Code/Datenzaehlerstand		   *
*		 cloc	 -  Codezaehlerstand				   *
*		 dloc	 -  Datenzaehlerstand				   *
*		 seg	 -  wenn PREL, dann ist	loc aktueller Codezaehler- *
*			    stand und dloc aktueller Datenzaehlerstand,	   *
*			    wenn DREL, dann ist	cloc aktueller		   *
*			    Codezaehlerstand und loc aktueller		   *
*			    Datenzaehlerstand.				   *
*									   *
* r/w globals :	 item	 -  zur	Codeerzeugung				   *
*		 type	 -   "						   *
*		 field	 -   "						   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID putsz()
  {
    item = DSIZE;	      /* Laenge	Datensegment (ABS !)		  */
    type = ABS;
    if (seg == DREL)
      field = loc;
    else
      field = dloc;
    putrel();

    item = PSIZE;	      /* Laenge	Programmsegment	(PREL !)	  */
    type = PREL;
    if (seg == PREL)
      field = loc;
    else
      field = cloc;
    putrel();
  }





/**************************************************************************\
*									   *
* action      :	 Shell-Sort fuer die Symboltabelle. Es werden die Zeiger   *
*		 stp alphabetisch sortiert.				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 l  -  unterer Index   des zu sortierenden Bereiches in	   *
*		 u  -  oberer Index    stp[]				   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 stp[]	-  Zeigerliste auf alle	Symbole	in der Symbol-	   *
*			   tabelle					   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID shell(l,u)

int l;
int u;

  {
    int	    gap;			/* Abstand Vergleich/Austausch	  */
    int	    i;				/* Laufindex gap + l bis u	  */
    int	    j;				/* Laufindex stp[]		  */
    char   *k;				/* Zwischenspeicher stp[]-Eintrag */
    int	    jg;				/* j + gap			  */

    gap	= (u - l + 1) >> 1;
    while (gap > 0)
      {
	i = gap	+ l;
	while (i <= u)
	  {
	    j =	i++ - gap;
	    while (j >=	l)
	      {
		jg = j + gap;
		if (strcmp(stp[j],stp[jg]) <= 0) break;
		k = stp[jg];
		stp[jg]	= stp[j];
		stp[j] = k;
		j -= gap;
	      }
	  }
	gap >>=	1;
      }
  }





/**************************************************************************\
*									   *
* action      :	 Symbol, auf dessen Eintrag in Symboltabelle cp	zeigt,	   *
*		 ausgeben an stdout. Der Symbolwert wird ASCII hex	   *
*		 vierstellig ausgegeben, je nach Symboltyp wird	folgendes  *
*		 angehaengt :						   *
*									   *
*		   absoluter Wert	  :  "	"			   *
*		   externer Wert	  :  "*	"			   *
*		   programrelativer Wert  :  "'	"			   *
*		   datenrelativer Wert	  :  ""	"			   *
*									   *
*		 Dann folgt das	Symbol,	es werden 6 Zeichen ausgegeben.	   *
*		 An das	Symbol wird je nach Symboltyp angehaengt :	   *
*									   *
*		   Label		  :   ":"			   *
*		   global bekanntes Label :   "::"			   *
*									   *
*		 Sind 60 Zeichen Zeilenlaenge erreicht,	wird ein CR/LF	   *
*		 ausgegeben, sonst wird	die Ausgabe auf	20 Zeichen mit	   *
*		 Spaces	aufgefuellt.					   *
*									   *
*		 Es wird auf Seitenanfang getestet und ggf. eine neue	   *
*		 Seite begonnen.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 cp	-  Zeiger auf Symboleintrag in Symboltabelle	   *
*									   *
* r/o globals :	 stdout	-  Standardausgabe				   *
*									   *
* r/w globals :	 ccnt	-  Zaehler Anzahl Zeichen/Zeile			   *
*		 lline	-  + 1,	wenn neue Zeile				   *
*									   *
* locals      :	 u	-  Symbolwert					   *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID show(cp)

char *cp;

  {
    unsigned u;

    begpage();					  /* ggf. neue Seite	  */
    u =	getuint(cp + STVALUE);			  /* Symbolwert	holen	  */
    printf("%04x",u);				  /* und ausgeben	  */
    if (cp[STFLAG] & XRBIT)			  /* External ?		  */
      fputs("* ",stdout);			  /* ja, * anhaengen	  */
    else					  /* nein, Relokationstyp */
      switch (cp[STFLAG] & RELBITS)		  /* markieren		  */
	{
	  case PREL :  fputs("'	",stdout);    break;
	  case DREL :  fputs("\" ",stdout);   break;
	  default   :  fputs("	",stdout);    break;
	}
    fputs(cp,stdout);				  /* Symbol ausgeben	  */
    ccnt += 6 +	strlen(cp);			  /* Zeichenzaehler	  */
    if (cp[STFLAG] & LABBIT)			  /* Label ?		  */
      {						  /* ja, : anhaengen	  */
	putchar(':');
	++ccnt;
      }
    if (cp[STFLAG] & EPBIT)			  /* globales Label ?	  */
      {						  /* ja, noch ein :	  */
	putchar(':');				  /* anhaengen		  */
	++ccnt;
      }
    if (ccnt < 60)				  /* Zeilenende	?	  */
      while (ccnt % 20)				  /* nein, formatieren	  */
	{
	  putchar(' ');
	  ++ccnt;
	}
    else					  /* ja, CR/LF		  */
      {
	puts("");
	++lline;
	ccnt = 0;
      }
  }





/**************************************************************************\
*									   *
* action      :	 Ausdruck auswerten, auf den lp	in Eingabezeile	zeigt.	   *
*		 Dieser	Ausdruck muss der letzte in der	Eingabezeile sein, *
*		 wenn nicht, wird entsprechendes Fehlerflag gesetzt.	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 lp	-  Zeiger auf den auszuwertenden Ausdruck	   *
*									   *
* r/w globals :	 ep	-  lokaler Zeiger auf auszuwertenden Ausdruck	   *
*		 field	-  Wert	des Ausdrucks nach Auswertung		   *
*		 type	-  Typ des Ausdrucks nach Auswertung		   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 YES: Ausdruck ist der letzte in der Eingabezeile	   *
*		 NO:  Ausdruck war nicht der letzte in der Eingabezeile	   *
*									   *
\**************************************************************************/

BOOLEAN	onexpr()
  {
    ep = lp;				/* Zeiger auf Ausdruckstring	  */
    expr(&field,&type);			/* Ausdruck auswerten		  */
    if (atend(*ep)) return (YES);	/* Ende	des Statements ?	  */
    experr();				/* nein, Fehler			  */
    return (NO);
  }





/**************************************************************************\
*									   *
* action      :	 Neues Symbol aus stsym	in Symboltabelle st ab stptr	   *
*		 aufnehmen, Alle Kleinbuchstaben aus stsym werden beim	   *
*		 Kopieren in Grossbuchstaben gewandelt.			   *
*									   *
*		 Nach dem Kopieren des Symbols sind die	Location- und	   *
*		 Flagfelder = 0..0, siehe Initialisierung in main().	   *
*									   *
*		 Wenn Symboltabelle voll (*stptr != 0) Programmabbruch mit *
*		 entsprechender	Meldung.				   *
*									   *
*		 Darf nur mit gueltigem	Zeiger stptr in	st aufgerufen	   *
*		 werden, d.h. nach stfind() !				   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 stsym	-  Symbolstring, nullterminiert			   *
*		 stptr	-  Zeiger auf Eintrag in st			   *
*									   *
* r/w globals :	 (st)	-  wenn	st nicht voll, wird das	Symbol an die	   *
*			   Stelle stptr	eingetragen			   *
*		 stp	-  stptr wird in stp[stn] eingetragen		   *
*		 stn	-  Index in stp, wird um 1 erhoeht		   *
*									   *
* locals      :	 dest	-  Zeiger zum Kopieren des Symb. nach stptr, Ziel  *
*		 sour	-  Zeiger zum Kopieren des Symb. von stsym, Quelle *
*									   *
* returns     :	 -							   *
*									   *
\**************************************************************************/

VOID addsym()
  {
    char *dest;
    char *sour;

    if (*stptr)	fatal("Symbol Table Overflow", "");
						  /* Symboltabelle voll	  */
    stp[stn++] = stptr;				  /* Symbolzeiger setzen  */
    dest = stptr;				  /* stsym nach	stptr	  */
    sour = stsym;				  /* kopieren		  */
    while ((*dest++ = toupper(*sour++))	!= 0x00) ;
  }





/**************************************************************************\
*									   *
* action      :	 Suchen	des Symbols in stsym (nullterminiert) in der	   *
*		 Symboltabelle st. Zunaechst Hashindex vom Symbol	   *
*		 berechnen, dann ab diesem Eintrag in st suchen, wrap	   *
*		 around	am Tabellenende. Wenn gefunden,	Rueckgabe des	   *
*		 Zeigers auf Eintrag in	stptr. Abbruch der Suche beim	   *
*		 naechsten st-Eintrag =	0..0 oder nachdem die gesamte	   *
*		 Tabelle erfolglos durchsucht wurde.			   *
*									   *
*		 Wenn Symbol nicht gefunden, dann enthaelt stptr den	   *
*		 Zeiger	auf den	fuer stsym passenden freien Eintrag in der *
*		 Symboltabelle (Hash, dann Suche zum naechsten leeren	   *
*		 Eintrag).						   *
*									   *
*		 Wenn Symbol nicht gefunden und	*stptr != 0, dann ist die  *
*		 Symboltabelle voll.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 -							   *
*									   *
* r/o globals :	 stsym	-  Symbolstring	des in st zu suchenden Symbols	   *
*		 (st)	-  Symboltabelle				   *
*		 stend	-  Zeiger hinter letzten Eintrag in st		   *
*									   *
* r/w globals :	 stptr	-  Zeiger in st	auf Symbol, falls gefunden	   *
*			-  Zeiger auf den passenden (Hash) naechsten	   *
*			   (*stptr == 0) freien	Eintrag	fuer Symbol sonst  *
*			-  falls Rueckgabe NO und *stptr != 0, dann	   *
*			   ist Symboltabelle voll			   *
*									   *
* locals      :	 start	-  Zeiger auf Anfang der Symbolsuche in	st	   *
*									   *
* returns     :	 YES wenn Symbol gefunden, NO sonst			   *
*									   *
\**************************************************************************/

BOOLEAN	stfind()
  {
    char *start;

    stptr = start = st + hash(stsym,STMAX) * STENTRY;  /* ab gehashtem	  */
    while (*stptr)				       /* Eintrag seq.	  */
      {						       /* suchen	  */
	if (strcmp(stsym,stptr)	== 0) return (YES);    /* gefunden !	  */
	if ((stptr += STENTRY) >= stend) stptr = st;   /* naechster E.	  */
	if (stptr == start) break;		       /* alles	durch	  */
      }
    return (NO);				       /* nicht	gefunden  */
  }





/**************************************************************************\
*									   *
* action      :	 Umwandlung eines Zeichenstrings in eine Zahl. Es werden   *
*		 folgende Zahlen umgewandelt :				   *
*									   *
*		   "c" oder 'c'	 -  ASCII-Wert von c			   *
*									   *
*		   Suffix  Q, O	 -  Oktalzahl				   *
*			   H	 -  Hexadezimalzahl			   *
*			   B	 -  Binaerzahl				   *
*									   *
*		 Bei Umwandlungsfehlern	wird entsprechendes Fehlerflag	   *
*		 gesetzt.						   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 at	-  Zeiger auf den String der umzuwandelnden Zahl   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 number	-  die umgewandelte Zahl			   *
*									   *
* locals      :	 s.u.							   *
*									   *
* returns     :	 Anzahl	zu der Zahl zugehoerigen Zeichen oder 0, wenn es   *
*		 keine Zahl war						   *
*									   *
\**************************************************************************/

int getnum(at)

char *at;

  {
    int	       bump;		   /* 1: Zahlstring mit	Suffix,	sonst 0	  */
    int	       len;		   /* Laenge Zahlstring	ohne Suffix	  */
    char      *end;		   /* Zeiger auf Ende Zahlstring	  */
    char      *cp;		   /* Zeiger auf Anfang	Zahlstring	  */
    BOOLEAN    isbin;		   /* YES: B als Suffix	oder in	Zahl	  */

    cp = at;					       /* lokaler Zeiger  */
    if ((*cp ==	'\'' ||	*cp == '"') && *cp == cp[2])   /* 'c', "c"	  */
      {
	number = cp[1] & 255;			       /* ASCII-Wert	  */
	return (3);				       /* Laenge	  */
      }
    if (isdigit(*cp))				       /* Zahl		  */
      {
	end = cp;	      /* Endezeiger, Endesuche beginnt am Anfang  */
	bump = 1;	      /* Default: Zahlstring hat Suffix		  */
	isbin =	NO;	      /* Start:	kein B in Zahl			  */
	LOOP		      /* fuer alle Zeichen der Zahl im String	  */
	  {
	    switch (toupper(*end))		       /* nur Uppercase	  */
	      {
		case 'Q' :			       /* Oktalzahl	  */
		case 'O' :  len	= otoi(cp,&number);
			    break;

		case 'H' :  len	= xtoi(cp,&number);    /* Hexzahl	  */
			    break;

		case 'B' :  isbin = YES;  /* Binaerzahl	oder B in Hexzahl */

		default	 :  if (isxdigit(*end))	       /* Zahl noch nicht */
			      {			       /* zuende	  */
				++end;
				continue;
			      }
			    if (isbin)		       /* Zahl zuende,	  */
			      {			       /* muss Binaerzahl */
				len= btoi(cp,&number); /* sein		  */
				--end;		       /* war 1	hinter B  */
			      }
			    else		       /* Zahl zuende,	  */
			      {			       /* muss Dezimal-	  */
				bump = 0;	       /* sein,	kein	  */
				len= utoi(cp,&number); /* Suffix	  */
			      }
			    break;
	      }
	    break;
	  }
	if (len	!= (end	- cp)) numerr();	  /* ungueltige	Zahl	  */
	return ((end - at) + bump);		  /* Laenge Zahlstring	  */
      }	/* end if (isdigit(*cp)) */
    return (0);					  /* keine Zahl, Fehler	  */
  }



/* Ende	von MAC4.C */
