/********************************************************/
/*							*/
/*		 Q/C Compiler (Part 4)			*/
/*							*/
/*     Copyright (c) 1985 Quality Computer Systems	*/
/*		 All Rights Reserved			*/
/*							*/
/*			08/27/85			*/
/********************************************************/

#include <stdio.h>
#include "qc.h"
#include "qcdecl.c"

/* This	section	is the recursive descent
 *	parser of C expressions.
 *	heir1()	thru heir15() implement
 *	the hierarchy of operators.
 */
/* Evaluate an expression */
void expression(load)
int load;
	{
	struct operand op;	/* op describes	the expression found */

	pregflag = FALSE;	/* no value in preg yet	*/
	tosflag	= FALSE;
	if (load) {		/* is the value	of expression needed? */
		heir1(&op, KEEP);
		curtyp = op.op_type;
		rvalp(&op);
		}
	else
		heir1(&op, NO_KEEP);
	unreftype(op.op_type);	/* remove reference from type table */
	}
/*	sequence operator (,)	*/
void heir1(op, keepflag)
struct operand *op;
int keepflag;
	{
	heir2(op, keepflag);
	while (matchc(',')) {
		pregflag = FALSE;
		tosflag	= FALSE;
		heir2(op, keepflag);	/* staying at this level causes	value */
				/* in preg to be right-most expression */
		}
	}
/*	assigment operators (=,	+=, |=,	etc.	*/
void heir2(lop,	keepflag)
register struct	operand	*lop;
int keepflag;
	{
	struct operand rop;
	register optype;
	struct typeinfo	*exprtype;
	static depth = 0;	/* keep	track of nesting depth */

	++depth;
	heir3(lop);
	if (matchc('=')) {
	    if (needlval(lop)) {
		doasgn(lop, &rop, depth, keepflag);
		unreftype(rop.op_type);
		}
	    }
	else {
	    optype = ch();		/* check for assignment	operator */
	    if ((match("+=") ||	match("|=") || match("^=")
		|| match("&=") || match("*=") || match("-=")
		|| match(">>=")	|| match("<<=")	|| match("/=")
		|| match("%="))	&& needlval(lop)) {
		curtyp = exprtype = lop->op_type;/* preserve type of expr */
		rvalpsav(lop);		/* get value of	var & save addr	*/
		binop(lop, optype, &rop, heir2);
		curtyp = exprtype;
		if ( cnvreq(lop->op_type, curtyp))
			cnvrtlt(lop, TO_CUR);
		chtype(lop, exprtype);
		store(lop, keepflag);		/* store result	(lop = lop op rop) */
		}
	    }
	--depth;
	}
/* parse a conditional expression e1 ? e2 : e3 */
#define	ZERO	1
#define	NONZERO	2
void heir3(op1)
register struct	operand	*op1;
	{
	register cexp1,	cexp2, cexp3;
	register label1, label2, savegflag, savepflag, savetflag;
	struct operand op2, op3;
	struct typeinfo	*comptyp(), *isptr(), *ptrtype2, *ptrtype3;

	heir4(op1);
	if (!matchc('?'))
		return;
	cexp1 =	cexp2 =	cexp3 =	FALSE;
	savegflag = genflag;
	if (isconstant(op1))
		cexp1 =	(op1->op_val) ?	NONZERO: ZERO;
	else {
		curtyp = op1->op_type;
		rvalp(op1);		/* load	e1 */
		jumpcond(FALSE,	label1=getlabel()); /* test e1 */
		getlabel();		/* reserve a label in case */
		}
	pregflag = FALSE;		/* new expression so preg empty	*/
	tosflag	= FALSE;
	genflag	= (savegflag &&	cexp1 != ZERO)?	/* generate code? */
			savegflag: FALSE;
	heir3(&op2);			/* evaluate e2 */
	needpunc(':');
	if (isconstant(&op2))
		cexp2 =	(op2.op_val) ? NONZERO:	ZERO;
	if (!cexp1) {			/* don't need jumps if e1 constant */
		curtyp = op2.op_type;
		rvalp(&op2);
		jump(label1 + 1);	/* don't evaluate e3 */
		linelabel(label1);	/* arrive here if e1 is	false */
		}
	savepflag = pregflag;
	savetflag = tosflag;
	pregflag = FALSE;
	tosflag	= FALSE;
	genflag	= (savegflag &&	cexp1 != NONZERO)? savegflag: FALSE;
	heir3(&op3);			/* evaluate e3 */
	genflag	= savegflag;
	if (isconstant(&op3))
		cexp3 =	(op3.op_val) ? NONZERO:	ZERO;
	if (cexp1 && cexp2 && cexp3) {	/* constant expression?	*/
		op1->op_val = (cexp1==NONZERO)?	op2.op_val: op3.op_val;
		return;
		}
	ptrtype2 = isptr(&op2);
	ptrtype3 = isptr(&op3);
	if ((ptrtype2 || ptrtype3) && ptrtype2 != ptrtype3
	  && cexp2 != ZERO && cexp3 != ZERO)
	    /*Error #426 Inconsistent use of pointers in conditional expression	*/
	    error(426);
	curtyp = comptyp(&op2, &op3);
	if (cexp1 == NONZERO) {
		pregflag = savepflag;	/* restore register flags */
		tosflag	= savetflag;
		rvalp(&op2);
		}
	else
		rvalp(&op3);
	if (cexp1)
		op1->op_load = EXPRESSION; /* record that op1 is loaded	*/
	else
		if (cnvreq(op2.op_type,	curtyp)) {
			jump(label2 = getlabel());
			linelabel(label1 + 1);
			pregflag = savepflag;	/* restore register op2	register flags */
			tosflag	= savetflag;
			cnvrtlt(&op2, TO_CUR); /* convert to proper type */
			linelabel(label2);
			}
		else
			linelabel(label1 + 1);	/* arrive here if e1 is	true */
	settype(&op2, &op3);
	chtype(op1, op2.op_type);	/* set type of result */
	unreftype(op2.op_type);		/* remove ref from type	table */
	}
/* parse a logical OR expression (e1 ||	e2) */
void heir4(lop)
register struct	operand	*lop;
	{
	struct operand rop;
	register resultset, label1;

	heir5(lop);		/* evaluate e1 */
	resultset = testdone;	/* if lop is test or &&, result	is set */
	blanks();
	if (!streq(lptr,"||"))
		return;
	label1 = getlabel();
	getlabel();		/* reserve a label in case we need it */
	curtyp = lop->op_type;
	rvalp(lop);
	while (match("||")) {
		jumpcond(TRUE, label1);	/* if e1 TRUE, expression is TRUE */
		pregflag = FALSE;
		heir5(&rop);		/* evaluate e2 */
		curtyp = rop.op_type;
		rvalp(&rop);
		unreftype(rop.op_type);
		resultset &= testdone;	/* record if result is set */
		}
	if (resultset)			/* see if result already set */
		linelabel(label1);
	else {
		jumpcond(FALSE,	label1 + 1); /*	if e2 0, e1||e2	is 0 */
		linelabel(label1);	/* arrive here if true */
		set1();			/* set value of	e1 || e2 to 1 */
		linelabel(label1 + 1);
		}
	testdone = TRUE;	/* record that we just did a test */
	chtype(lop, sinttype);	/* result of logical OR	is integer */
	}
/* parse a logical AND expression (e1 && e2) */
void heir5(lop)
register struct	operand	*lop;
	{
	struct operand rop;
	register resultset, label1;

	heir6(lop);
	resultset = testdone;		/* if lop is test, result is set */
	blanks();
	if (!streq(lptr,"&&"))
		return;
	label1 = getlabel();
	curtyp = lop->op_type;
	rvalp(lop);			/* load	lop in preg if necessary */
	while (match("&&")) {
		jumpcond(FALSE,	label1); /* if e1 is false, we're thru */
		pregflag = FALSE;
		heir6(&rop);		/* evaluate e2 */
		curtyp = rop.op_type;
		rvalp(&rop);
		unreftype(rop.op_type);
		resultset &= testdone;	/* record if result is set */
		}
	if (!resultset)	{		/* see if result must be set */
		jumpcond(FALSE,	label1); /* if e2 is 0,	e1&&e2 is 0 */
		set1();
		}
	linelabel(label1);		/* false label */
	testdone = TRUE;
	chtype(lop, sinttype);		/* result of logical AND is int	*/
	}
/* bitwise inclusive OR	*/
void heir6(lop)
struct operand *lop;
	{
	struct operand rop;

	heir7(lop);
	blanks();
	for (;;) {
		if (nch() != '|' && nch() != '=' && matchc('|')) {
			if (binop(lop, '|', &rop, heir7) == CONSTANT)
				lop->op_val |= rop.op_val;
			}
		else break;
		}
	}
/* bitwise exclusive OR	*/
void heir7(lop)
struct operand *lop;
	{
	struct operand rop;

	heir8(lop);
	blanks();
	for (;;) {
		if (nch() != '=' && matchc('^')) {
			if (binop(lop, '^', &rop, heir8) == CONSTANT)
				lop->op_val ^= rop.op_val;
			}
		else break;
		}
	}
/* bitwise AND */
void heir8(lop)
struct operand *lop;
	{
	struct operand rop;

	heir9(lop);
	blanks();
	for (;;) {
		if (nch() != '&' && nch() != '=' && matchc('&')) {
			if (binop(lop, '&', &rop, heir9) == CONSTANT)
				lop->op_val &= rop.op_val;
			}
		else
			break;
		}
	}
void heir9(lop)
register struct	operand	*lop;
	{
	struct operand rop;

	heir10(lop);
	for (;;) {
		if (match("==")) {
			if (binop(lop, EQ, &rop, heir10) == CONSTANT)
				lop->op_val = (lop->op_val == rop.op_val);
			}
		else if	(match("!=")) {
			if (binop(lop, NE, &rop, heir10) == CONSTANT)
				lop->op_val = (lop->op_val != rop.op_val);
			}
		else
			break;
		chtype(lop, sinttype); /* result of equality op	is int */
		}
	}
void heir10(lop)
register struct	operand	*lop;
	{
	struct operand rop;

	heir11(lop);
	for (;;) {
		if (match("<=")) {
			if (binop(lop, LE, &rop, heir11) == CONSTANT)
				lop->op_val = (lop->op_val <= rop.op_val);
			}
		else if	(match(">=")) {
			if (binop(lop, GE, &rop, heir11) == CONSTANT)
				lop->op_val = (lop->op_val >= rop.op_val);
			}
		else if	(nch() != '<' && matchc('<')) {
			if (binop(lop, LT, &rop, heir11) == CONSTANT)
				lop->op_val = (lop->op_val < rop.op_val);
			}
		else if	(nch() != '>' && matchc('>')) {
			if (binop(lop, GT, &rop, heir11) == CONSTANT)
				lop->op_val = (lop->op_val > rop.op_val);
			}
		else
			break;
		chtype(lop, sinttype); /* result of relation op	is int */
		}
	}
void heir11(lop)
struct operand *lop;
	{
	struct operand rop;

	heir12(lop);
	blanks();
	for (;;) {
		if (!streq(lptr,">>=") && match(">>")) {
			if (binop(lop, '>', &rop, heir12) == CONSTANT)
				lop->op_val >>=	rop.op_val;
			}
		else if	(!streq(lptr,"<<=") && match("<<")) {
			if (binop(lop, '<', &rop, heir12) == CONSTANT)
				lop->op_val <<=	rop.op_val;
			}
		else
			break;
		}
	}
void heir12(lop)
struct operand *lop;
	{
	struct operand rop;
	heir13(lop);
	blanks();
	while (nch() !=	'=') {
		if (matchc('+')) {
			heir13(&rop);
			doadd(lop, &rop);
			}
		else if	(matchc('-')) {
			heir13(&rop);
			dosub(lop, &rop);
			}
		else
			break;
		}
	}
void heir13(lop)
register struct	operand	*lop;
	{
	struct operand rop;

	heir14(lop);
	blanks();
	while (nch() !=	'=') {
		if (matchc('*')) {
			heir14(&rop);
			domult(lop, &rop);
			}
		else if	(matchc('/')) {
			if (binop(lop, '/', &rop, heir14) == CONSTANT)
				lop->op_val /= rop.op_val;
			}
		else if	(matchc('%')) {
			if (binop(lop, '%', &rop, heir14) == CONSTANT)
				lop->op_val %= rop.op_val;
			}
		else break;
		}
	}
/* heir14 calls	itself because unary operators */
/*	associate left to right	*/
void heir14(op)
register struct	operand	*op;
	{
	register struct	st *sym;
	register struct	typeinfo *type;
	register size, sawparen, savegflag, savepflag, savetflag;
	struct typeinfo	*abstdecl(), *isptr(), *ptrto();

	if (match("++")) {		/* pre-increment */
		heir14(op);
		if (needlval(op))
			addto(op, 1);
		return;
		}
	if (match("--")) {		/* pre-decrement */
		heir14(op);
		if (needlval(op))
			addto(op, -1);
		return;
		}
	if (nextc('-'))	{		/* unary minus (negation) */
		if (constant(op))	/* check for negative constant */
			return;
		gch();
		heir14(op);		/* evaluate expression */
		curtyp = op->op_type;
		rvalp(op);		/* load	in preg	*/
		cneg();			/* negate preg */
		return;
		}
	if (matchc('*')) {		/* indirection */
		heir14(op);		/* evaluate expression */
		if (!isptr(op))
			/*Error	#427 Not a pointer */
			error(427);
		else {
			curtyp = op->op_type;
			rvalp(op);
			op->op_sym = NULL;/* record that addr of lvalue	*/
			op->op_load = (LOADVALUE|LVALUE); /* is	in preg	*/
			deref(op);	/* remove a layer of ptr */
			}
		return;
		}
	if (matchc('!')) {		/* logical not (!exp) */
		heir14(op);		/* evaluate expression */
		curtyp = op->op_type;
		rvalp(op);		/* load	in preg	*/
		ccomp("n");		/* logical not of preg */
		chtype(op, sinttype);	/* result is always int	*/
		return;
		}
	if (matchc('~')) {		/* one's complement (~exp) */
		heir14(op);
		if (isconstant(op))
			op->op_val = ~op->op_val; /* constant expression */
		else {
			curtyp = op->op_type;
			rvalp(op);	/* load	in preg	*/
			clogic("com");	/* complement preg */
			}
		return;
		}
	if (matchc('&')) {		/* address */
		heir14(op);
		sym = op->op_sym;
		if (!islval(op)	||
		   (sym	!= NULL	&& sym->st_sc == SC_REG)) {
			/*Error	#428 Illegal address */
			error(428);
			return;
			}
		chtype(op, ptrto(op->op_type));	/* chg type to ptr_to_type */
		op->op_load &= ~(LVALUE|LOADVALUE); /* no longer lvalue	*/
		if (op->op_sym != NULL)	{ /* if	not already loaded...*/
			op->op_load |= LOADADDR;/* need	to load	address	*/
			setconstaddr(op); /* check for constant	address	*/
			}
		return;
		}
	if (amatch("sizeof")) {
		sawparen = matchc('(');
		if ((type = abstdecl())	!= NULL) { /* sizeof abstract declarator */
			reftype(op->op_type = sinttype);
			size = type->t_size;
			if (sawparen)
				needpunc(')');
			}
		else {			/* sizeof a variable */
			if (sawparen)
				putback('(');
			dumpeep();	/* output peephole buffer */
			savegflag = genflag;
			savepflag = pregflag;
			savetflag = tosflag;
			pregflag = tosflag = genflag = FALSE;
			heir14(op);
			genflag	= savegflag;
			pregflag = savepflag;
			tosflag	= savetflag;
			size = op->op_type->t_size;
			chtype(op, sinttype);
			}
		if (size < 0)
			size = 0;	/* unknown size	*/
		op->op_val = size;
		op->op_sym = NULL;
		op->op_load = (LOADVALUE|CONSTANT);
		return;
		}
	if (matchc('(')) {		/* check for cast */
		if ((type = abstdecl())	!= NULL) {
			needpunc(')');
			heir14(op);
			curtyp = type;
			rvalp(op);
			chtype(op, type); /* take care of base type differences	*/
			return;		/* which rvalp & curtyp	do not look at */
			}
		else
			putback('(');
		}
	heir15(op);			/* look	for a primary expression */
	if (match("++")) {		/* post-increment */
		if (needlval(op))
		addto(op, 1);
		increment(op, -1);	/* recover original value */
		return;
		}
	if (match("--")) {		/* post-decrement */
		if (needlval(op))
			addto(op, -1);
		increment(op, 1);
		return;
		}
	}
void heir15(op1)
register struct	operand	*op1;
	{
	register dot, offset;
	struct operand op2;
	struct typeinfo	*isptr();

	primary(op1);
	for (;;) {
		if (matchc('(')) {	/* function call */
			if (op1->op_type->t_code != T_FUNC)
				/*Error	#429 Not a function */
				error(429);
			callfunction(op1);
			deref(op1);	/* change to type func returns */
			op1->op_load = EXPRESSION; /* and mark as loaded */
			return;
			}
		else if	((dot=matchc('.')) || match("->")) {
			if (!dot) {	/* structure reference */
				curtyp = op1->op_type;
				rvalp(op1);
				op1->op_sym = NULL; /* says addr in preg */
				}
			if (!ismember(&op2)) {
				/*Error	#430 Not a structure or	union member */
				error(430);
				op1->op_load = EXPRESSION;
				}
			else {
				offset = op2.op_sym->st_info;
				if (dot	&& (op1->op_sym	!= NULL))
					op1->op_val += offset;
				else
					addconst( (long) offset);
				op1->op_load = (LVALUE|LOADVALUE);/*member is lval*/
				chtype(op1, op2.op_type); /* use member	info */
				setconstaddr(op1); /* chk for constant address */
				unreftype(op2.op_type);
				}
			}
		else if	(matchc('[')) {	/* check for array reference */
			heir1(&op2, KEEP);
			doadd(op1, &op2);
			if (op1->op_load == EXPRESSION)
				op1->op_sym = NULL; /* says addr in preg */
			else			/* not an array	now */
				op1->op_load &=	~LOADADDR;
			op1->op_load |=	(LVALUE|LOADVALUE);
			if (isptr(op1))
				deref(op1);
			else {
				/*Error	#431 Can't subscript */
				error(431);
				op1->op_load = EXPRESSION;
				}
			needpunc(']');
			}
		else
			break;
		}
	}
/* See if next token is	a structure or union member */
int ismember(op)
struct operand *op;
	{
	char name[NAMESIZE];
	register struct	st *p;
	struct st *findtag();

	if (!symname(name))
		return FALSE;
	else if	((p=findtag(name)) == NULL || p->st_sc == SC_TYPE)
		return FALSE;
	else {
		initop(op, p, p->st_type, LVALUE|LOADVALUE);
		return TRUE;
		}
	}
/* Evaluate a primary expression */
void primary(op)
register struct	operand	*op;
	{
	register struct	st *sym;
	register struct	typeinfo *type;
	struct typeinfo	*ptrto();
	struct st *addglb(), *addloc(),	*findglb(), *findloc();
	char *chksym(),	name[NAMESIZE];

	if (matchc('(')) {
		heir1(op, KEEP);	/* start a new expression */
		needpunc(')');	/*	one level down */
		return;
		}
	if (chksym(name)) {	/* see if next token is	legal name */
		skip();
		if (!(sym = findloc(name))) {	/* is it a local? */
		    if ((sym = findglb(name)) != NULL) {  /* or	a global? */
			if (sym->st_info==DECL_LOC) /* declared	locally? */
				sym = NULL;	/* not known here */
			else if	(libflag && infunc)
				addloc(name, sym->st_type, SC_EXTERN,
					ID_VAR,	0);
			}
		    }
		if (sym) {		/* if it's defined ... */
			type = sym->st_type;
			initop(op, sym,	type, EXPRESSION);
			switch (type->t_code) {
			case T_LABEL:
				/*Error	#432 Illegal use of label */
				errname(432,sym->st_name);
				break;
			case T_FUNC:	/* if not a call... */
				if (!nextc('(')) { /* make ptr-to-func */
					chtype(op, ptrto(type));
					op->op_load = LOADADDR;
					}
				break;
			case T_ARRAY:	/* chg array-of-x to ptr-to-x */
				op->op_load = LOADADDR;
				break;
			default:	/* other types are lvalue */
				op->op_load = (LVALUE|LOADVALUE);
				break;
				}
			setconstaddr(op); /* chk for constant address */
			return;
			}
		if (nextc('('))	{	/* is it a function reference? */
			addglb(name, ifunctype,	SC_EXTERN, ID_VAR, DECL_LOC);
			sym = addloc(name, ifunctype, SC_EXTERN, ID_VAR, 0);
			initop(op, sym,	ifunctype, EXPRESSION);
			}
		else {	/* try to avoid	more errors by defining	*/
			/*Error	#433 Undefined variable	*/
			errname(433,name);
			type = (nextc('[')) ? ptrto(sinttype): sinttype;
			sym = addloc(name, type, SC_EXTERN, ID_VAR, 0);
			initop(op, sym,	type, (LOADVALUE|LVALUE));
			}
		return;
		}
	/* This	should be a constant or	a string */
	if (!constant(op) && !string(op)) { /* if not, it's an error */
		savepreg();
		lsimmed(0, PREG);
		/*Error	#434 Invalid expression	*/
		error(434);
		if (ch() != ';')
			junk();		/* skip	bad stuff */
		initop(op, (struct st *) NULL, sinttype, EXPRESSION);
		}
	}
/* Change array	reference to address of	array */
void unarray(op)
register struct	operand	*op;
	{
	if (op->op_sym!=NULL &&	!isloaded(op)) /* if op	is not loaded */
		op->op_load |= LOADADDR; /* must reference by address */
	op->op_load &= ~(LVALUE|LOADVALUE); /* array has no lvalue */
	}
/* Check for constant address or constant offset from stack pointer */
void setconstaddr(op)
register struct	operand	*op;
	{
	register sc;

	if (op->op_load	& LOADADDR) {	/* is op referenced by addr? */
		sc = op->op_sym->st_sc;
		if (sc == SC_GLOBAL || sc == SC_ST_GLB
		   || sc == SC_EXTERN || sc == SC_STATIC)
			op->op_load |= CONSTADDR;
		else if	(sc == SC_AUTO)
			op->op_load |= CONSTOFF;
		}
	}
/* Initialize an expression operand */
void initop(op,	sym, type, load)
register struct	operand	*op;
struct st *sym;
struct typeinfo	*type;
int load;
	{
/*
	extern char *_free;
	if ((char *)(&load) <= _free)
		fatal("\nError #184 Out	of memory");
*/
	op->op_sym = sym;
	reftype(op->op_type = type);
	op->op_val = 0;		/* offset of variable starts at	zero */
	op->op_load = load;
	}
int needlval(op)
struct operand *op;
	{
	if (islval(op))
		return TRUE;
	else {
		/*Error	#435 Must be lvalue */
		error(435);
		return FALSE;
		}
	}
/* end of QC4.C	*/

