/********************************************************/
/*							*/
/*		 Q/C Compiler (Part 6)			*/
/*							*/
/*     Copyright (c) 1985 Quality Computer Systems	*/
/*		 All Rights Reserved			*/
/*							*/
/*			08/27/85			*/
/********************************************************/

#include <stdio.h>
#include "qc.h"
#include "qcdecl.c"


/* This	section	contains code generation routines which
 * reflect the architecture of the target machine but
 * which don't generate	any assembler mnemonics
 */

/* Generate trace message */
void gentrace(inout, funcname)
int inout;
char *funcname;
	{
	static label;			/* hold	label from entry to exit call*/
	register leaving;

	leaving	= (inout == '<');
	if (leaving)
		cpush(PREG);		/* save	return value */
	else {
		dataseg();		/* build trace message */
		label =	getlabel();
		linelabel(label);
		defbyte();
		outdec(' ');		/* enter (>) or	exit (<) */
		do {			/* print function name */
			outbyte(',');
			outdec((int) *funcname);
			} while	(*funcname++);
		codeseg();
		}
	pimmed();			/* load	address	of message */
	printlabel(label);
	nl();
	ldmemi(inout);			/* enter (>) or	exit (<) */
	cpush(PREG);
	ccall("puts");			/* print message */
	cpop(PREG);			/* clear arg off stack */
	if (leaving)
		cpop(PREG);		/* restore return value	*/
	}
/*
 * Do binary operators
 *	Return:	CONSTANT if constant expression
 *		FALSE	 if not
 */
int binop(lop, op, rop,	heirn)
register struct	operand	*lop, *rop;
register op;
void (*heirn)();
	{
	register oprev;
	struct typeinfo	*comptyp(), *isptr();

	(*heirn)(rop, KEEP);
	curtyp = comptyp(lop, rop);
	if (specialcase(lop, op, rop))
		return FALSE;
	else if	((oprev=loadops(lop, rop)) == CONSTANT)
		return CONSTANT;
	switch (op) {
	case '|':
		clogic("o");
		break;
	case '^':
		clogic("x");
		break;
	case '&':
		clogic("a");
		break;
	case EQ:
		ccomp("e");
		break;
	case NE:
		ccomp("ne");
		break;
	case LE:
		(oprev)	? ccomp("ge"): ccomp("le");
		break;
	case GE:
		(oprev)	? ccomp("le"): ccomp("ge");
		break;
	case LT:
		(oprev)	? ccomp("gt"): ccomp("lt");
		break;
	case GT:
		(oprev)	? ccomp("lt"): ccomp("gt");
		break;
	case '>':
		cord("sr", oprev);
		break;
	case '<':
		cord("sl", oprev);
		break;
	case '%':
		cord("rem", oprev);
		break;
	case '/':
		cord("div", oprev);
		break;
		}
	return FALSE;
	}
int specialcase(lop, op, rop)
register struct	operand	*lop, *rop;
int op;
	{
	struct typeinfo	*comptyp();

	switch(op) {
	case '*':
		domult(lop, rop);
		break;
	case '-':
		dosub(lop, rop);
		break;
	case '+':
		doadd(lop, rop);
		break;
	case EQ:
		if (!isconstant(lop) &&	isconstant(rop)
			 && ! is32bit(curtyp = comptyp(lop, rop))) {
			rvalp(lop);
			switch ((int) rop->op_val) {
			case -1:
				cinc();
				goto case0;
			case 1:
				cdec();
			case 0:	case0:
				ccomp("n");
				break;
			default:
				rvals(rop);
				ccomp("e");
				break;
				}
			unreftype(sinttype);
			break;
			}
	default:
		return FALSE;
		}
	return TRUE;
	}
/* Add rop to lop */
void doadd(lop,	rop)
register struct	operand	*lop, *rop;
	{
	register struct	typeinfo *lptrtype, *rptrtype;
	struct typeinfo	*comptyp(), *isptr();
	long n;

	curtyp = comptyp(lop, rop);
	if (isconstant(lop) && isconstant(rop))	{
		lop->op_val += rop->op_val; /* constant	expression */
		unreftype(curtyp);
		return;
		}
	if (!is32bit(curtyp)) {
		lptrtype = isptr(lop);
		rptrtype = isptr(rop);
		if (isconstant(rop)) {		/* do special cases */
			if (lptrtype)		/* must	scale for pointers */
				n = rop->op_val	* basesize(lop);
			else
				n = rop->op_val;
			if ((lop->op_load & LOADADDR)
			&& (lop->op_load & (CONSTADDR|CONSTOFF)))
				lop->op_val += n; /* change offset only	*/
			else {
				rvalp(lop);	/* load	lop if necessary */
				addconst(n);
				}
			unreftype(rop->op_type);
			return;
			}
		if (isconstant(lop)) {
			if (rptrtype)
				lop->op_val *= basesize(rop);
			if ((rop->op_load & LOADADDR)
			   && (rop->op_load & (CONSTADDR|CONSTOFF)))
				lop->op_val += rop->op_val;	/* offset has been changed */
			else {
				rvalp(rop);	/* load	rop if necessary */
				addconst(lop->op_val);
				}
			chtype(lop, rop->op_type); /* now lop is that type */
			lop->op_load = rop->op_load; /*	record loading info */
			lop->op_sym = rop->op_sym;
			unreftype(rop->op_type);
			return;
			}
		if (lptrtype) {		/* must	scale for pointer addition */
			if (rptrtype)
				/*Error	#456 Can't add pointers	*/
				error(456);
			rvalp(rop);
			multconst(basesize(lop));
			}
		else if	(rptrtype) {
			rvalp(lop);
			multconst(basesize(rop));
			chtype(lop, rop->op_type);
			}
		}
	loadops(lop, rop);
	cadd();
	}
void addto(op,sign)
register struct	operand	*op;
int sign;
	{
	curtyp = op->op_type;
	rvalpsav(op);
	increment(op, sign);
	store(op, KEEP);
	}
void increment(op, sign)
register struct	operand	*op;
int sign;
	{
	struct typeinfo	*isptr();

	curtyp = op->op_type;
	if (isptr(op))
		addconst( (long) sign *	basesize(op));
	else
		addconst( (long) sign);
	}
/* Subtract rop	from lop */
void dosub(lop,	rop)
register struct	operand	*lop, *rop;
	{
	register struct	typeinfo *lptrtype, *rptrtype;
	register size;
	struct typeinfo	*comptyp(), *isptr();

	if (isconstant(rop)) {
		rop->op_val = -rop->op_val;
		doadd(lop, rop);	/* do lop + (-rop) */
		return;
		}
	curtyp = comptyp(lop, rop);
	if(is32bit(curtyp)) {
		cord("s",loadops(lop, rop));
		return;
		}
	rptrtype = isptr(rop);
	lptrtype = isptr(lop);
	if (lptrtype &&	!rptrtype) {
		rvalp(rop);		/* scale for ptr - scalar */
		multconst(basesize(lop));
		}
	cord("s",loadops(lop, rop));
	if (rptrtype) {
		if (!lptrtype)
			/*Error	#457 Can't subtract pointer from scalar	*/
			error(457);
		else if	(lptrtype != rptrtype)
			/*Error	#458 Can't subtract unlike pointers */
			error(458);
		else {
			/* it's	ptr - ptr so compute occurrences */
			size = basesize(lop);
			if (size > 1) {
				lsimmed(size,SREG);/* and divide by size */
				curtyp = sinttype; /* Note that	this calculation is not	*/
				cord("div", TRUE); /* correct if the items pointed to are */
				}	/* more	than 2**15-1 bytes apart */
			chtype(lop, sinttype); /* now it's just	a count	*/
			}
		}
	}
/* Multiply lop	by rop */
void domult(lop, rop)
register struct	operand	*lop, *rop;
	{
	struct typeinfo	*comptyp();

	curtyp = comptyp(lop, rop);
	if (isconstant(lop) && isconstant(rop))	{
		lop->op_val *= rop->op_val;	/* constant expression */
		unreftype(rop->op_type);
		return;
		}
	if (is32bit(curtyp)) {
		loadops(lop, rop);
		cmult();
		return;
		}
	if (isconstant(rop)) {
		rvalp(lop);
		multconst((int)	rop->op_val);	/* chk for special cases */
		}
	else if	(isconstant(lop)) {
		rvalp(rop);
		multconst((int)	lop->op_val);
		chtype(lop, rop->op_type);	/* record what we did */
		lop->op_load = EXPRESSION;
		}
	else {
		loadops(lop, rop);
		cmult();
		return;
		}
	unreftype(rop->op_type);
	}
/* Multiply primary reg	by 'size' */
void multconst(size)
int size;
	{
	switch (size) {
	case 64: doublereg();
	case 32: doublereg();
	case 16: doublereg();
	case  8: doublereg();
	case  4: doublereg();
	case  2: doublereg();
	case  1: return;
	default:
		lsimmed(size, SREG);
		cmult();
		return;
		}
	}
/* Do a	function call */
void callfunction(func)
register struct	operand	*func;
	{
	register struct	typeinfo *type;
	register argsize;
	struct operand arg;
	register char *currarg,	*startarg;
	register struct	st *sym;
	auto saveflag, savegflag, savepflag, savetflag;

	blanks();
	dumpeep();			/* flush peephole buffer */
	sym = func->op_sym;
	if (sym	== NULL	||		/* if we're calling address in preg */
		pregflag) {		/* or preg contains something...*/
		cpush(PREG);		/* save	it */
		pregflag = FALSE;
		}
	if (tosflag) {			/* if tos is in	use, save it */
		callib("pshtos");
		tosflag	= FALSE;
		}
	saveflag = savepflag = savetflag = FALSE;
	savegflag = genflag;
	if (savegflag == GENCODE) {
		genflag	= GENARG;
		parg = argwork;		/* clear arg work area */
		*parg =	'\0';
		}
	startarg = parg;		/* record start	of arg code */
	argsize	= 0;
	while (!streq(lptr,")")) {	/* process arguments */
		if (endst())
			break;		/* premature end of function call */
		currarg	= parg;		/* record start	of current arg code */
		heir2(&arg, KEEP);	/* get arg, but	no comma ops */
		type = arg.op_type;
		if (type->t_code == T_STRUCT ||	type->t_code ==	T_UNION) {
			/*Error	#459 Can't pass	structures or unions */
			error(459);
			arg.op_load &= ~LOADVALUE; /* chg to ptr ref */
			arg.op_load |= LOADADDR;
			}
		curtyp = type;
		rvalp(&arg);
		if (is32bit(curtyp)) {
			callib("stk32");
			argsize	+= 4;
			}
		else {
			cpush(PREG);	/* push	addr or	arg in preg */
			argsize	+= 2;
			}
		reverse(currarg);	/* reverse code	for current arg	*/
		unreftype(type);	/* remove type table ref */
		tosflag	= pregflag = FALSE; /* clear register use flags	*/
		if (!matchc(','))	/* any more arguments? */
			break;
		}
	needpunc(')');
	reverse(startarg);		/* reverse code	for arguments */
	if (sym)
		ccall(sym->st_name);	/* call	named function */
	else
		calladdr(argsize+=2);	/* else	call address of	function */
	if (is32bit(func->op_type->t_base.p_type))
		savetflag = TRUE;
	else {
		savepflag = TRUE;
		saveflag = TESTED;	/* return value	is tested by function*/
		}
	clearstk(argsize);
	testflag = saveflag;
	tosflag	= savetflag;
	pregflag = savepflag;
	genflag	= savegflag;
	if (genflag == GENCODE)		/* if this is outer function call */
		outstr(argwork);	/*  output all arg loading code	*/
	}
/* Load	a character in the argument reversal work area */
void loadarg(c)
int c;
	{
	static warned =	FALSE;
	if (parg-argwork < argwsize) {
		*parg =	c;
		*++parg	= '\0';
		warned = FALSE;
		}
	else if	(!warned) {
		warned = TRUE;
		/*Error	#760 Argument work space full */
		error(760);
		}
	}
/* Reverse the characters in a string */
void reverse(s)
char *s;
	{
	register char *p, *q;
	register c;
	for (p=s, q=p+strlen(p)-1; p < q; ++p, --q) {
		c = *p;
		*p = *q;
		*q = c;
		}
	}
/* Copy	an argument into a register */
void argtoreg(p, regno)
register struct	st *p;
int regno;
	{
	struct operand arg;

	initop(&arg, p,	p->st_type, LOADVALUE);
	pregflag = FALSE;
	curtyp = arg.op_type;
	rvalp(&arg);			/* copy	arg into preg */
	p->st_sc = SC_REG;
	p->st_info = regno;
	arg.op_sym = p;
	store(&arg, NO_KEEP);
	unreftype(p->st_type);
	}
/* Load	operands in the	proper registers
 *	Return:	CONSTANT if both operands are constant
 *		TRUE	if operands are	loaded in
 *			reverse	of normal order
 *		FALSE	otherwise
 */
int loadops(lop, rop)
register struct	operand	*lop, *rop;
	{
	register oprev;
	struct typeinfo	*comptyp();

	curtyp = comptyp(lop, rop);
	if (isconstant(lop) && isconstant(rop))	{
		unreftype(rop->op_type);
		chtype(lop, curtyp);
		return CONSTANT;
		}
	oprev =	FALSE;		/* record order	operands are loaded */
	if (is32bit(curtyp)) {
	    if((isloaded(rop) && is32bit(rop->op_type))
		|| (isaddr(rop)	|| isloaded(rop) && !is32bit(rop->op_type))
		    && !(is32bit(lop->op_type) && isloaded(lop))) {
		rvalp(rop);
		tosflag	= FALSE;     /*	This allows rvalp to be	used to	*/
		if (isaddr(lop)	&& ! pregflag) { /* load second	operand	*/
			cpop(PREG);
			pregflag = TRUE;
			}
		rvalp(lop);
		}
	    else {
		rvalp(lop);
		if ((isloaded(rop) || isaddr(rop)) && !	pregflag) {
			cpop(PREG);
			pregflag = TRUE;
			}
		tosflag	= FALSE;
		rvalp(rop);
		oprev =	TRUE;
		}
		}
	else {
		if (isconstant(lop)) {
		/* LOP is CONSTANT */
			rvalp(rop);			/* ROP not CONSTANT */
			rvals(lop);
			}
		else if	(isloaded(lop))	{
		/* LOP is already LOADED */
			if (isloaded(rop))		/* ROP is LOADED */
				cpop(SREG);		/* retrieve lop	in sreg	*/
			else if	(isconstant(rop)) {
							/* ROP is CONSTANT */
				rvals(rop);		/* rop into sreg */
				oprev =	TRUE;		/* reverse order */
				}
			else if	(isaddr(rop)) {		/* ROP is ADDRESS */
				rvalp(rop);		/* addr	of rop in preg */
				cpop(SREG);		/* retrieve lop	*/
				}
			else {				/* ROP is VARIABLE */
				swap_reg();		/* move	lop into sreg */
				pregflag = FALSE;	/* preg	empty */
				rvalp(rop);		/* load	rop into preg */
				}
			}
		else if	(isaddr(lop)) {
		/* LOP ADDRESS is in PREG */
			if (isloaded(rop)) {		/* ROP is LOADED */
				swap_reg();		/* move	rop into sreg */
				pregflag = FALSE;	/* preg	empty */
				cpop(PREG);		/* retrieve lop	addr */
				rvalp(lop);		/* load	lop in preg */
				oprev =	TRUE;		/* reverse order */
				}
			else if	(isaddr(rop)) {		/* ROP is ADDRESS */
				rvals(rop);		/* rop into sreg */
				cpop(PREG);		/* get addr of lop */
				rvalp(lop);		/* lop in preg */
				oprev =	TRUE;		/* reverse order */
				}
			else {				/* ROP CONSTANT	or VAR */
				rvals(lop);		/* lop indirect	to sreg	*/
				rvalp(rop);		/* rop into preg */
				}
			}
		else {
		/* LOP is a VARIABLE */
			if (isconstant(rop)) {		/* ROP is CONSTANT */
				rvalp(lop);		/* lop in preg */
				rvals(rop);		/* rop in sreg */
				oprev =	TRUE;		/* reverse order */
				}
			else if	(isloaded(rop))	{	/* ROP is LOADED */
				swap_reg();		/* rop into sreg */
				pregflag = FALSE;	/* preg	empty */
				rvalp(lop);		/* lop into preg */
				oprev =	TRUE;		/* reverse order */
				}
			else if	(isaddr(rop)) {		/* ROP is ADDRESS */
				rvals(rop);		/* rop indirect	to sreg	*/
				rvalp(lop);		/* lop into preg */
				oprev =	TRUE;		/* reverse order */
				}
			else {				/* ROP is VARIABLE */
				rvalp(lop);		/* lop in preg */
				swap_reg();		/* switch to sreg */
				pregflag = FALSE;	/* preg	empty */
				rvalp(rop);		/* rop in preg */
				}
			}
		}
	settype(lop, rop);	/* set type of expression */
	return oprev;
	}
/* Get the value of op in preg */
void rvalp(op)
register struct	operand	*op;
	{
	register load_info;
	if (isloaded(op)) {
		if (is32bit(op->op_type)) {
			if (tosflag != TRUE) {
				savepreg();
				callib("poptos");
				tosflag	= TRUE;
				}
			}
		else if	(!pregflag) {
			cpop(PREG);
			pregflag = TRUE;
			}
		if (op->op_type->t_code	!= curtyp->t_code)
			cnvrtlt(op, TO_CUR);
		return;
		}
	if (isaddr(op))	{		/* addr	of op already loaded */
		indirect(op);
		op->op_load = EXPRESSION;
		return;
		}
	if (is32bit(curtyp))
		savetos();
	savepreg();			/* save	preg if	it's in	use */
	load_info = op->op_load;
	if (load_info &	(CONSTANT|ASGCONST)) /*	is it a	constant? */
			lopimmed(op, PREG);
	else if	(load_info & LOADADDR)	/* do we want the address... */
		getaddr(op);
	else if	(load_info & LOADVALUE)	/* or the value	of op? */
		load(op);
	op->op_load = EXPRESSION;	/* record that op is loaded */
	}
/* Get the value of op in preg and */
/* save	its address if it's not	fixed. */
void rvalpsav(op)
register struct	operand	*op;
	{
	if (op->op_sym == NULL)		/* if addr of op already in preg */
		cpush(PREG);		/* save	it */
	else if	(op->op_sym->st_sc == SC_AUTO
			|| is32bit(curtyp) || is32bit(op->op_type)) {
		savepreg();
		getaddr(op);		/* load	address	and */
		cpush(PREG);		/* save	it */
		}
	rvalp(op);
	}
/* Get the value of op in sreg */
void rvals(op)
register struct	operand	*op;
	{
	if (isconstant(op))
		lopimmed(op, SREG); /* load value immediate */
	else if	(op->op_sym == NULL) {	/* address is in preg */
		sindirect(op);
		}
	op->op_load = EXPRESSION;	/* record that op is loaded */
	}
/* Load	a floating point constant into preg at run time	*/
void ld_float(op)
register struct	operand	*op;
	{
	register struct	typeinfo *ffunctype; /*	type function returning	float*/
	struct typeinfo	*addtype();

	savetos();			/* save	top of 32 bit stack if in use*/
	rvalp(op);			/* make	constant string	arg to atof */
	cpush(PREG);
	ccall("atof");			/* do the conversion to	float */
	clearstk(2);			/* sizeof Z80 pointer */
	pregflag = FALSE;		/* preg	no longer in use */
	tosflag	= TRUE;			/* top of 32 bit stack now in use */
	ffunctype = addtype(T_FUNC, (union baseinfo *) &floattype, 0);
	reftype(ffunctype);		/* create type if necessary */
	addglb("atof", ffunctype, SC_EXTERN, ID_VAR, DECL_LOC);	/* gen EXTRN */
	}
/* Load	operand	into preg */
void load(op)
register struct	operand	*op;
	{
	register struct	st *sym;

	sym = op->op_sym;
	if (peepflag ==	PREGSYM	&& strcmp(sym->st_name,	peepsym) == 0
	   && (int)op->op_val == peepoffset && op->op_type->t_size==peeplen) {
		pregflag = TRUE;
		if (op->op_type->t_code	!= curtyp->t_code)
			cnvrtlt(op, TO_CUR);
		return;		/* sym is already in preg */
		}
	if (sym->st_sc == SC_AUTO)
		autoload(op);
	else
		qgetmem(op);
	}
/* Convert the type of an operand which	is already loaded to or
	from the current type */
void cnvrtlt(op, tocurnt)
struct operand *op;
register int tocurnt;
	{
	register struct	typeinfo *from_type, *to_type;
	register int from_code,	to_code;
	if (tocurnt) {
		from_type = op->op_type;
		to_type	= curtyp;
		chtype(op, curtyp);
		}
	else {
		from_type = curtyp;
		to_type	= op->op_type;
		}
	from_code = from_type->t_code;
	to_code	= to_type->t_code;
	if (is32bit(to_type)) {
		if (!is32bit(from_type)) {
			savetos();
			if (!pregflag)
				cpop(PREG);
			if (from_code == T_CHAR	|| from_code ==	T_SHORT)
				callib("ptots");
			else
				callib("ptotu");
			pregflag = FALSE;
			tosflag	= TRUE;
			}
		if (to_code != T_LONG && from_code != T_FLOAT)
			callib("ltof");	/* when	to type	is float and from type
						is one of the integer types */
		else if	(from_code == T_FLOAT)
			callib("ftol");
		}
	else if	(is32bit(from_type)) {
		/* to type is 16 bit, from type	is 32 bit */
		if (from_code != T_LONG)
			callib("ftol");
		savepreg();
		callib("ttop");
		tosflag	= FALSE;
		pregflag = TRUE;
		}
	}
/* Store preg into operand op */
void store(op, keepflag)
register struct	operand	*op;
register int keepflag;
	{
	if (op->op_sym == NULL)		/* store at address on stack */
		putstk(op, keepflag);
	else
		putmem(op, keepflag);		/* store in memory */
	if (keepflag)
		op->op_load = EXPRESSION;	/* keep	op from	being loaded */
	}
/* Load	specified operand indirect into	preg */
void indirect(op)
register struct	operand	*op;
	{
	register size;
	register struct	typeinfo *ld_type;
	ld_type	= op->op_type;
	if (is32bit(curtyp))
		findirect(op);
	else if	(is32bit(ld_type)) {
		if (ld_type->t_code == T_LONG)
			callib("gl");
		else {
			callib("g32bit");
			callib("ftol");
			callib("ttop");
			}
		pregflag = TRUE;
		}
	else {
		size = ld_type->t_size;
		if (peepflag ==	ADDRSFP) {
			clearpeep();		/* clear pattern buffer	*/
			callib((size ==	1) ? "gcf": "gf");
			}
		else
			callib((size ==	1) ? "gc": "g");
		pregflag = TRUE;
		}
	if (curtyp->t_code != ld_type->t_code)
		chtype(op, curtyp);
	}
/* Load	specified object size indirect thru preg into sreg */
void sindirect(op)
register struct	operand	*op;
	{
	register struct	typeinfo *ld_type;
	register size;
	ld_type	= op->op_type;
	if (is32bit(curtyp)) {
		tosflag	= FALSE;
		findirect(op);
		}
	else if	(is32bit(ld_type)) {
		if (ld_type->t_code == T_LONG)
			callib("gls");
		else {
			callib("g32bit");
			callib("ftol");
			callib("ttos");
			}
		}
	else {
		size = ld_type->t_size;
		callib((size ==	1) ? "gcs" : "gs");
		}
	pregflag = FALSE;
	if (curtyp->t_code != ld_type->t_code)
		chtype(op, curtyp);
	}
/* Load	TOS indirect through PREG */
void findirect(op)
register struct	operand	*op;
	{
	register struct	typeinfo *ld_type;
	ld_type	= op->op_type;
	pregflag = TRUE;
	savetos();
	if (!pregflag)
		cpop(PREG);
	if (is32bit(ld_type))
		callib("g32bit");
	else {
		if (peepflag ==	ADDRSFP) {
			clearpeep();
			loadpeep("\tLD\tL,C\n\tLD\tH,B\n");
			peepflag = ADDRSFP;
			}
		switch(ld_type->t_code)	{
			case T_CHAR:
				callib("g32c");	/* load	TOS from 8 bit signed character	*/
				break;
			case T_SHORT:
				callib("g32s");	/* load	TOS from 16 bit	signed integer */
				break;
			default:
				callib("g32u");	/* remaining types treated as 16 bit unsigned */
				break;
			}
		}
		if (curtyp->t_code != T_LONG) {
			if (ld_type->t_code != T_FLOAT)
				callib("ltof");
			}
		else {
			if (ld_type->t_code == T_FLOAT)
				callib("ftol");
			}
		pregflag = FALSE;
		tosflag	= TRUE;
		}
/* Add constant	amt to primary reg */
void addconst(amt)
long amt;
	{
	struct operand op;

	if (is32bit(curtyp)) {
		initop(&op, (struct st *) NULL,	sinttype, (LOADVALUE|CONSTANT));
		op.op_val = amt;
		rvals(&op);
		cadd();
		unreftype(op.op_type);
		return;
		}
	else {
		switch ((int) amt) {
			case 3:	cinc();
			case 2:	cinc();
			case 1:	cinc();
			case 0:	return;
			case -3: cdec();
			case -2: cdec();
			case -1: cdec();
				return;
			default:
				lsimmed((int)amt, SREG);
				cadd();
				return;
			}
		}
	}
/* Obtain a function name prefix dependent upon	the current type */
char fprfx()
	{
	switch(curtyp->t_code) {
		case T_UNSIGNED:
		case T_PTR:
		case T_ARRAY:
			return 'u';
		case T_LONG:
			return 'l';
		case T_FLOAT:
		case T_DOUBLE:
			return 'f';
		default:
			return 's';
		}
	}
/* Do a	logical	operation which	returns	1 or 0 and sets	the Z80	Z flag.
     argument		operation
	n		not
	e		equal
	ne		not equal
	lt		less than
	le		less than or equal
	gt		greater	than
	ge		greater	than or	equal		*/
void ccomp(root)
char *root;
	{
	char name[9];
	char fprfx(), *strcat();
	name[0]	= fprfx();
	name[1]	= '\0';
	if (is32bit(curtyp)) {
		savepreg();
		pregflag = TRUE;
		tosflag	= FALSE;	/* result is always short integer */
		}
	else if	(name[0] == 'u'	&& (*root == 'n' || *root == 'e'))
		name[0]	= 's';	/* Cases of "not", "not	equal",	and "equal"
				are not	different for unsigned and signed. */
	callib(strcat(name, root));
	testdone = TRUE;
	}
/* Call	function for order dependent operations. */
void cord(root,	oprev)
register char *root;
register int oprev;
	{
	char name[9];
	register saveflag;
	char *strcat(),	fprfx();

	saveflag = 0;
	name[0]	= fprfx();
	if (name[0] == 'f'
			&& ((*root == 's' && *(root + 1) != '\0')
				|| *root == 'r')) {
		fltoperr();		/* invalid operation on	float */
		name[0]	= 'l';
		}
	if (*root == 's' && *(root+1) != 'r') {
		if (name[0] == 'u')
			name[0]	= 's';	/* Signed and unsigned shift left and subtract
						are the	same. */
		if (name[0] == 's' && *(root+1)	== '\0')
			saveflag = REGH; /* Set	testflag for short subtract. */
		}
	if (oprev) {
		name[1]	= '1';
		name[2]	= '\0';
		}
	else
		name[1]	= '\0';
	callib(strcat(name, root));
	testflag = saveflag;
	}
/* Bitwise logical operations.
    argument		operation
	o		or
	x		exclusive or
	a		and
	com		complement		*/
void clogic(root)
register char *root;
	{
	char name[9];
	char *strcat(),	fprfx();

	name[0]	= fprfx();
	name[1]	= '\0';
	if (name[0] == 'f') {
		fltoperr();		/* invalid operation on	float */
		name[0]	= 'l';
		}
	if (name[0] == 'u')
		name[0]	= 's';	/* Same	operation for signed and unsigned. */
	callib(strcat(name, root));
	if(name[0] == 's')
		testflag = (*root == 'c')? REGL: REGH;
	}
/* Multiply preg by sreg */
void cmult()
	{
	char name[6];
	char *strcat(),	fprfx();

	name[0]	= fprfx();
	name[1]	= '\0';
	callib(strcat(name, "mult"));
	}
/* two's complement of preg */
void cneg()
	{
	switch(curtyp->t_code) {
		case T_FLOAT:
			callib("fneg");
			return;
		case T_LONG:
			callib("lneg");
			return;
		default:
			callib("sneg");
			testflag = REGL;       /* remember that	L is in	A */
			return;
		}
	}
/* Save	preg if	it's in	use */
void savepreg()
	{
	if (pregflag) {
		cpush(PREG);
		pregflag = FALSE;
		}
	}
/* Save	tos if its in use */
void savetos()
	{
	if (tosflag) {
		savepreg();
		callib("pshtos");
		tosflag	= FALSE;
		}
	}
/* Load	operand	immediate */
void lopimmed(op, reg)
register struct	operand	*op;
register int reg;
	{
	register val;

	if (is32bit(curtyp)) {
		savepreg();
		if (tosflag && reg == PREG)
			savetos();
		tosflag	= FALSE;
		lsimmed((int) op->op_val, PREG);
		if (op->op_type->t_size	== 4) {
			val = op->op_val >> 16;
			if (val	== 0)
				callib("ptotu"); /* don't sign extend */
			else {
				lsimmed(val, SREG);
				callib("ptotl");
				}
			tosflag	= TRUE;
			pregflag = FALSE;
			}
		if (op->op_type	!= curtyp)
			cnvrtlt(op, TO_CUR);
		}
	else
		lsimmed((int) op->op_val, reg);
	}
/* Do an immediate load	of n into reg */
void lsimmed(n,	reg)
int n, reg;
	{
	if (reg	== PREG) {
		pimmed();
		pregflag = TRUE;
		}
	else
		simmed();
	outdec(n);
	nl();
	}
/* Print a name	so it won't upset the assembler	*/
void outname(name)
char *name;
	{
	register c;
	register char *s;

	s = name;
	while ((c = *s++) != 0)
		outbyte((c=='_') ? ASMULINE: c);
	if (*name != ASMRTS)	/* don't change	library	function names */
		outbyte(ASMRTS);
	}
/* Print specified number as label */
void printlabel(label)
int label;
	{
	outbyte(ASMRTS);
	outdec(label);
	}
/* Generate a compiler label in	the peephole buffer */
void peeplabel(label)
int label;
	{
	static char s[7] = {ASMRTS};
	char *itob();

	itob(label, s+1, 10);
	loadpeep(s);
	loadpeep("\n");
	}
/* Load	pattern	into peephole optimization buffer */
void loadpeep(s)
char *s;
	{
	char *strcat();
	strcat(peepbuf,	s);
	}
/* Dump	the contents of	the peephole buffer */
void dumpeep()
	{
	peepflag = FALSE;
	outstr(peepbuf);
	clearpeep();
	}
/* Clear the peephole pattern buffer */
void clearpeep()
	{
	peepflag = FALSE;
	*peepbuf = '\0';
	}
/* end of QC6.C	*/

