/********************************************************/
/*							*/
/*		 Q/C Compiler (Part 9)			*/
/*							*/
/*     Copyright (c) 1985 Quality Computer Systems	*/
/*		 All Rights Reserved			*/
/*							*/
/*			09/05/85			*/
/********************************************************/

#include <stdio.h>
#include <ctype.h>
#include "qc.h"
#include "qcdecl.c"


/* NOTE: This module becomes part of the free space after it
 *	 is used if you	link Q/C using PLINK-II	or the LE linker
 */

/* Initialize */
void init()
	{
	printf("NORD><LINK C Z80 Crosscompiler Version 1.0a\n");
	printf("ported to Linux	by dl4sdc\n\n");
	printf("This software is NOT public domain. It was given to you\n");
	printf("as a radio amateur for noncommercial use ONLY.\n");
	printf("(by special permission of Quality Computer Systems)\n");
	minsym = nsym;
	minlit = litpsize;
	}
/* Get options from command line */
void getoptions(argc, argv)
int argc;
char *argv[];
	{
	register char *p;
	char *strchr(),	*strcat(), *strcpy();
	static rename =	FALSE;

	if (argc < 2)			/* need	at least one input file	*/
		usagerr();
	nextfil	= argv + 1;
	while (--argc) {
		if (**++argv ==	'-')
			break;		/* stop	at options */
		++ninfils;
		}
	if (ninfils == 0)
		usagerr();		/* must	have an	input file */
	getfilename(*nextfil, infil, "C");
	while (argc--) {		/* look	for options */
		p = *argv++;
		if (*p == '-') {
		    while (*++p) {
			switch (tolower(*p)) {
			case 'c':	/* commented asm listing */
				fullist	= TRUE;
				continue;
			case 'd':	/* output to console (debug) */
				output = stderr;
				coutput	= stderr;
				continue;
			case 'i':	/* toggle initialization of */
				initflag = !initflag; /* arrays>INITSIZE */
				continue;
			case 'l':	/* generate a library */
				libflag	= TRUE;
				continue;
			case 'o':	/* rename output file */
				rename = 1;
				continue;
			case 'r':	/* toggle redirection flag */
				redirect = !redirect;
				continue;
			case 's':	/* exclude shell in ROM	code */
				romflag	= TRUE;
				lptr = p + 1;	/* look	for stk	addr */
				spaddr = gethex();
				break;
			case 't':	/* generate trace messages */
				trace.is_on = trace.enabled = TRUE;
				continue;
			case 'v':	/* toggle verbose/terse	*/
				verbose	= !verbose;
				continue;
			default:
				usagerr();
				}
			break;		/* break out of	-S switch */
			}
		    }
		else if	(rename	== 1) {	/* should be new output	file name */
		    if (p[1] ==	':' && p[2] == '\0') { /* only a drive?	*/
			strcpy(coutfil,	p); /* build drive:infil.defext	*/
			strcat(coutfil,	infil[1]==':' ?	infil+2	: infil);
			*(strchr(coutfil, '.') + 1) = '\0';
			strcat(coutfil,	defext);
			}
		    else {
			getfilename(p, coutfil,	defext);
			/* use output file .ext	for library extension as well*/
			strcpy(defext, strchr(coutfil, '.') + 1);
			}
		    if (streq(infil, coutfil)) {
			puts("Output file name same as input");
			exit(1);
			}
		    rename = 2;		/* remember we did it */
		    }
		else
			usagerr();
		}
	if (!rename && coutput == 0) {	/* use infil.defext for	code output */
		strcpy(coutfil,	infil);
		*(strchr(coutfil, '.')+1) = '\0'; /* end name after '.'	*/
		strcat(coutfil,	defext); /* add	default	extension */
		}
	else if	(rename	== 1)		/* new file name not found */
		usagerr();
	}
/* Convert string to hex value */
int gethex()
	{
	register int d;
	register unsigned v;

	v = 0;
	for (;;) {
		d = toupper(ch());
		if (isdigit(d))
			d -= '0';
		else if	(d >= 'A' && d <= 'F')
			d -= ('A' - 10);
		else
			break;
		v = (v<<4) | d;
		gch();
		}
	return ((int) v);
	}
void usagerr()
	{
	/*Error	#190 Usage:qc infile ... -cdilortv -sxxxx outfile */
	fatal("\nError #190 Usage:qc infile ...	-cdilortv -sxxxx outfile");
	}
/* Obtain compiler table and buffer space from free space */
void getspace()
	{
	peepbuf	= clrsbrk(64);
	line =	clrsbrk(LINESIZE);
	mline =	clrsbrk(LINESIZE);
	parg = argwork = clrsbrk(argwsize);
	pcasetab =
	casetab	=
		(struct	case_table *)
		clrsbrk(ncases * sizeof(struct case_table));
	pswq =
	swq =
		(struct	swq *) clrsbrk(nswq * sizeof(struct swq));
	typelist =
		(struct	typeinfo *)
		clrsbrk(n_types	* sizeof(struct	typeinfo));
	freemem	=
	memtab =
		(struct	memtab *) clrsbrk(nmem * sizeof(struct memtab));

	plitpool =
	litpool	=
		clrsbrk(litpsize);
	symtab =
	glbptr =
		(struct	st *) clrsbrk(nsym * sizeof(struct st));
	locptr = STARTLOC;
	sym_hash = (struct st_hash *) clrsbrk(nsym * sizeof(struct st_hash));
	sym_ovflow = sym_hash +	nsym-1;

	mac_hash = (struct mp_hash *) clrsbrk(n_mac * sizeof(struct mp_hash));
	mac_ovflow = mac_hash +	n_mac-1;

	if ((int)symtab==-1 || (int)litpool==-1	|| (int)mac_hash==-1)
		/*Error	#191 Not enough	table space */
		fatal("\nError #191 Not	enough table space");
	}
/* end of QC9.C	*/

