/**************************************************************************\
*									   *
*   QCX.C   -	unido CHiPSy Crosscompiler				   *
*									   *
*		Zusatzfunktionen fuer Q/C, die nicht in	jeder Library	   *
*		zu finden sind.						   *
*									   *
*									   *
*					Michael	Roehner, unido ChiPSy	   *
*									   *
\**************************************************************************/





/**************************************************************************\
*									   *
* action      :	 Integer n in String s der Basis base konvertieren.	   *
*									   *
*		 base darf zwischen 2 und 36 liegen fuer Konvertierungen   *
*		 ohne Vorzeichen, oder -10 sein	fuer Dezimalkonvertierung  *
*		 mit Vorzeichen.					   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 n	-  zu konvertierende Integerzahl		   *
*		 s	-  Zeiger auf String, in den n konvertiert wird	   *
*		 base	-  Basis (2-36 oder -10) des Zahlensystems, das	   *
*			   fuer	den String benutzt wird			   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 u	   -  n	ohne Vorzeichen, Ergebnis nach Teilen	   *
*		 p	   -  Zeiger in	s				   *
*		 q	   -  Zeiger in	s bei Stellenumkehr		   *
*		 negative  -  1	wenn n < 0, 0 sonst			   *
*		 c	   -  Zeichenbuffer bei	Stellenumkehr		   *
*									   *
* returns     :	 s							   *
*									   *
\**************************************************************************/

char *itob(n,s,base)

int n;
char *s;
int base;

  {
    register unsigned	 u;
    register char	*p;
    register char	*q;
    register int	 negative;
    register int	 c;

    if (n < 0 && base == -10)		/* Vorzeichen nur beachten, wenn  */
      {					/* Stellenwertsystem dezimal mit  */
	negative = 1;			/* Vorzeichen			  */
	u = -n;
      }
    else
      {
	negative = 0;
	u = n;
      }
    if (base ==	-10) base = 10;		/* Basisvorzeichen loeschen	  */
    p =	q = s;				/* Zahlenzeichenfolge in umge-	  */
    do					/* kehrter Reihenfolge erzeugen	  */
      {
	if((*p = u % base + '0') > '9')	*p += ('A' - ('9' + 1));
	++p;
      }
    while ((u /= base) > 0);
    if (negative) *p++ = '-';
    *p = '\0';				/* Zeichenfolge	beenden		  */
    while (q < --p)			/* Stellenreihenfolge umkehren	  */
      {
	c    = *q;
	*q++ = *p;
	*p   = c;
      }
    return (s);
  }





/**************************************************************************\
*									   *
* action      :	 imin  -  Minimum zweier Integerwerte zurueckgeben	   *
*		 imax  -  Maximum zweier Integerwerte zurueckgeben	   *
*									   *
 **************************************************************************
*									   *
* parameter   :	 i,j	-  die beiden Integerwerte, s.o.		   *
*									   *
* r/o globals :	 -							   *
*									   *
* r/w globals :	 -							   *
*									   *
* locals      :	 -							   *
*									   *
* returns     :	 s.o.							   *
*									   *
\**************************************************************************/

int imin (i,j)
int i,j;
  {
    return ((i < j) ? i	: j);
  }

int imax (i,j)
int i,j;
  {
    return ((i > j) ? i	: j);
  }





/**************************************************************************\
*									   *
* (Entspricht strchr() aus dem ANSI-Standard)				   *
*									   *
\**************************************************************************/

char *strchr(s,c)

register char *s;
char c;
  {
    while (*s)
      {
	if (*s == c) return (s);
	++s;
      }
    return ((char *)0);
  }



/* Ende	von QCX.C */
